define(function (require) {
  return function (context) {

    var $grid, $form;

    // 输入搜索文本后点击回车按钮查询列表
    function enterQueryGrid1(e) {
      if (e.keyCode === 13) {
        var tmp = $(this).val();
        $form.formSet({queryProperties: tmp});
        queryGrid1();
      }
    }

    //　查询列表
    function queryGrid1() {
      var queryUrl = '/sys/account/query';// 自行替换此参数
      $grid.jqGrid("clearGridData");
      var queryForm = $form.formGet();
      $grid.reload({
        mtype: 'POST',
        url: api(queryUrl),
        queryParams: queryForm
      });
    }

    // 搜索按钮
    var queryToolbarTitle = '帐号管理';
    var queryToolbar = {
      xtype: 'toolbar', title: queryToolbarTitle, items: [
        {
          text: '查询', iconCls: 'fa fa-search', onClick: function () {
            queryGrid1();
          }
        }, {
          text: '重置', iconCls: 'fa fa-refresh', onClick: function () {
            $form.formClear();
            queryGrid1();
          }
        }, {
          text: '关闭', iconCls: 'fa fa-times-circle', onClick: function () {
            App.closeMe(this);
          }
        }
      ]
    };

    // 搜索条件
    var queryFormPrompt = '姓名/用户名';
    var queryForm = {
      onRender: function () {
        $form = $(this);
      },
      xtype: 'form',
      items: [[
        {
          xtype: 'textbox',
          label: '检索条件',
          name: 'queryProperties',
          prompt: queryFormPrompt,
          labelWidth: 'auto',
          events: {keydown: enterQueryGrid1},
        },
        {
          xtype: 'yvselect', label: '启用状态', name: 'status', labelWidth: 'auto', width: 180, editable: false,
          data: $.yvan.sysDict('accountStatus').combowithAll(), value: '',
          onChange: function () {
            queryGrid1();
          }
        },
      ]]
    };

    // 列表增删改查按钮
    var gridToolbarTitle = '帐号列表';
    var gridToolbar = {
      xtype: 'toolbar', title: gridToolbarTitle,
      items: [
        {
          text: '新增', iconCls: 'fa fa-plus-circle', onClick: function () {
            var dlg = require('/app/sys/account/dialogAccount.js')({// 自行替换此参数
              isEdit: false,
              confirm: function () {
                queryGrid1();
              }
            });
            $.yvan.showDialog(this, dlg);
          }
        }, {
          text: '编辑', iconCls: 'fa fa-pencil-square-o', onClick: function () {
            var row = $grid.rowData();
            if (!row) {
              $.yvan.msg('请先选择一行数据');
              return;
            }
            var dlg = require('/app/sys/account/dialogAccount.js')({// 自行替换此参数
              isEdit: true,
              accId: row.accId,// 自行替换此参数
              confirm: function () {
                queryGrid1();
              }
            });
            $.yvan.showDialog(this, dlg);
          }
        }
      ]
    }

    return {
      center: {
        border: false,
        items: {
          onRender: function () {
            $grid = $(this);
            queryGrid1();
          },
          xtype: 'grid',
          idField: "accId",
          toolbar: {
            xtype: 'div',
            items: [
              queryToolbar,
              queryForm,
              gridToolbar
            ]
          },
          columns: [[
            {title: '账号ID', field: 'accId', hidden: true},
            {title: '用户名', field: 'account'},
            {title: '类型', field: 'accType', formatter: $.fn.fmatter.accTypeSrc},// 需要在format.js文件中设置此方法
            {title: '用户ID', field: 'userId', hidden: true},
            {title: '人员', field: 'userName'},
            {title: '部门ID', field: 'deptId', hidden: true},
            {title: '部门', field: 'orgName'},
            {title: '启用状态', field: 'status', hidden: true},
            {title: '启用状态', field: 'statusView', formatter: $.fn.fmatter.accountStatusView},
            {title: '新增人', field: 'userCreate', hidden: true},
            {title: '新增时间', field: 'timeCreate', formatter: 'ts'},
            {title: '更新人', field: 'userUpdate', hidden: true},
            {title: '更新时间', field: 'timeUpdate', formatter: 'ts'}
          ]]
        }
      }
    };
  };
});