define(function (require) {
  return function (context) {

    var $dlg, $grid;

    //　查询列表
    function queryGrid1() {
      var queryUrl = '/sys/menu/queryAll';// 自行替换此参数
      $grid.jqGrid("clearGridData");
      $grid.reload({
        mtype: 'GET',
        url: api(queryUrl),
        queryParams: {"sysId": context.sysId, "menuId": context.treeUp, "treeUp": context.treeUp}
      });
    }

    //编辑工具栏
    var gridToolbarTitle = '菜单列表';// 自行替换此参数
    var gridToolbar = {
      xtype: 'toolbar', title: gridToolbarTitle, items: [
        {
          text: '上移', iconCls: 'fa fa-arrow-up', onClick: function () {
            $grid.moveUp();
          }
        },
        {
          text: '下移', iconCls: 'fa fa-arrow-down', onClick: function () {
            $grid.moveDown();
          }
        },
        {
          text: '保存排序', iconCls: 'fa fa-check-square', onClick: function () {
            moveGrid();
          }
        }
      ]
    }

    //保存排序
    function moveGrid() {
      var gridData = $grid.jqGrid("getRowData");
      var list = [];
      for (var i = 0; i < gridData.length; i++) {
        list.push(gridData[i].menuId);
      }
      var treeCode = "";
      if (context.treeLev > 1) {
        treeCode = context.treeCode.substr(0, 3);
      }
      saveSort("sysMenu", list, context.sysId, treeCode);
    }

    function saveSort(name, ids, sysid, codeup) {
      var data = {
        "ids": "",
        "name": name,
        "sysId": sysid,
        "codeUp": codeup,
      };
      for (var i = 0; i < ids.length; i++) {
        data.ids += ids[i] + ","
      }
      data.ids = data.ids.substr(0, data.ids.length - 1);
      if (data.ids == "") {
        return;
      }
      $.yvan.ajax({
        url: api('/core/app/updateCoreSortCode'),
        method: 'post',
        data: data,
        beforeSend: function () {
          $.yvan.progress();
        },
        success: function () {
          $.yvan.msg('操作成功');
          $.yvan.progress();
          $dlg.window('close');
          if ($.type(context.confirm) === 'function') {
            context.confirm();
          }
        },
        complete: function () {
          $.yvan.closep();
        }
      });
    }

    return {
      xtype: 'dialog',
      dialogId: 'dialogMenuSort',
      title: '维护菜单排序',
      width: 900,
      height: 650,
      onOpen: function () {
        $dlg = $(this);
      },
      center: {
        border: false,
        items: {
          onRender: function () {
            $grid = $(this);
            queryGrid1();
          },
          xtype: 'grid',
          pagination: false,
          idField: "sysMenuSort",
          toolbar: {
            xtype: 'div',
            items: [
              gridToolbar
            ]
          },
          columns: [[
            {title: '菜单ID', field: 'menuId', hidden: true},
            {title: '平台ID', field: 'sysId', hidden: true},
            {
              title: '图标', field: 'menuIcon', align: "center", formatter: function (v) {
                return "<i class='" + v + "'></i>";
              }
            },
            {title: '菜单名称', field: 'menuName', hidden: true},
            {title: '菜单名称', field: 'menuNameView', formatter: $.fn.fmatter.treeNameView},// 树结构需要fmatter
            {title: '菜单编码', field: 'menuCode', hidden: true},
            {title: '功能URL', field: 'menuUrl'},
            {title: '备注', field: 'remark'},
            {title: '上级', field: 'treeUp', hidden: true},
            {title: '级别', field: 'treeLev', hidden: true},
            {title: '排序', field: 'treeSort', hidden: true},
          ]]
        }
      }
    };
  };
});