define(function (require) {
  return function (context) {
    // alert(context.sysId);
    var $dlg, $form;

    //自动生成助记码
    function onblurCustomerName() {
      $('body').item('tpName').textbox('setValue', $(this).val());
      var customerName = $('body').item('tpName').textbox("getValue");
      if (null != customerName && "" != customerName && undefined != customerName) {
        $('body').item('tpCodeM').val(top.pinyin.getCamelChars(customerName));
        $('body').item('tpNamePy').val(top.pinyin.getFullChars(customerName));
        var a = $('body').item('tpCodeM').val();
        var b = $('body').item('tpNamePy').val();
        $('body').item('tpCodeM').textbox('setValue', a);
        $('body').item('tpNamePy').textbox('setValue', b);
      }
    }

    //获取平台列表
    function getDataSysList() {
      var _datas = [];
      $.yvan.ajax({
        url: api('/sys/system/query'),
        data: {status: 1},
        method: 'post',
        async: false,
        success: function (data) {
          if (data.data != null && data.data != undefined) {
            for (var i = 0; i < data.data.length; i++) {
              _datas.push({
                "id": data.data[i].sysId,
                "text": data.data[i].sysName
              })
            }
          }
        }
      });
      return _datas;
    }

    return {
      xtype: 'dialog',
      dialogId: 'dialogDictTp',
      title: '分类基本属性',
      width: 650,
      height: 350,
      onOpen: function () {
        $dlg = $(this);
        if (context.isEdit) {
          $.yvan.ajax({
            loadingMask: false,
            url: api('/sys/sysDictTp/getById'),
            type: 'GET',
            data: {
              dictTp: context.dictTp
            },
            success: function (data) {
              $dlg.find('form');
              $form.formSet(data.data);
            }
          });
        } else {
          $.yvan.ajax({
            loadingMask: false,
            url: api('/sys/sysDictTp/getTpCode'),
            type: 'GET',
            success: function (data) {
              $dlg.find('form');
              $form.formSet({
                beActive: 'Y',
                status: 1,
                isBase: 0,
                sysId: context.sysId
              });
            }
          });
        }
      },
      center: {
        items: {
          xtype: 'formgroup',
          onRender: function () {
            $form = $(this);
          },
          items: [[
            {name: 'dictTp', xtype: 'hidden'},
            {
              name: 'sysId',
              label: '所属平台',
              xtype: 'yvselect',
              required: true,
              disabled: context.isEdit ? "disabled" : "",
              data: getDataSysList(),
            },
            {name: 'status', label: '启用状态', xtype: 'yvselect', required: true, data: $.yvan.sysDict('status').combo()},
            {name: 'tpName', label: '分类名称', required: true, ff: 10, events: {blur: onblurCustomerName}},
            {name: 'tpNamePy', label: '名称拼音', readonly: true},
            {name: 'tpCode', label: '分类编码', required: true, ff: 10},
            {name: 'tpCodeM', label: '助记码', readonly: true},
            {name: 'remark', label: '备注', span: 2, height: '60px', multiline: true},
          ]]
        }
      },
      buttons: [
        {
          text: "提交", iconCls: "fa fa-save", onClick: function () {
            $.yvan.postForm($form, {
              url: (context.isEdit ? api('/sys/sysDictTp/update') : api('/sys/sysDictTp/insert')),
              success: function () {
                $.yvan.msg('操作成功');
                if (context.isEdit) {
                  $dlg.window('close');
                }
                if ($.type(context.confirm) === 'function') {
                  context.confirm();
                }
              },
              error: function (data) {
              }
            });
          }
        }, {
          text: "关闭", iconCls: "fa fa-times", onClick: function () {
            $dlg.dialog('close');
          }
        }
      ]
    };
  };
});
