define(function (require) {
  return function (context) {

    var $dlg, $form;

    //自动生成助记码
    function onblurName() {
      $('body').item('dictName').textbox('setValue', $(this).val());
      var customerName = $('body').item('dictName').textbox("getValue");
      if (null != customerName && "" != customerName && undefined != customerName) {
        $('body').item('dictCodeM').val(top.pinyin.getCamelChars(customerName));
        $('body').item('dictNamePy').val(top.pinyin.getFullChars(customerName));
        var a = $('body').item('dictCodeM').val();
        var b = $('body').item('dictNamePy').val();
        $('body').item('dictCodeM').textbox('setValue', a);
        $('body').item('dictNamePy').textbox('setValue', b);
      }
    }

    return {
      xtype: 'dialog',
      dialogId: 'dialogDictTpDet',
      title: '维护字典信息',
      width: 620,
      height: 320,
      onOpen: function () {
        $dlg = $(this);
        if (context.dictId > 0) {
          $.yvan.ajax({
            loadingMask: false,
            url: api('/sys/sysDictTpDet/getById'),
            type: 'GET',
            data: {
              dictId: context.dictId
            },
            success: function (data) {
              $dlg.find('form');
              if (!isNotNull(data) || !isNotNull(data.data)) {
                return;
              }
              $form.formSet(data.data);
            }
          });
        }
        else if (context.treeUp > 0) {
          $.yvan.ajax({
            loadingMask: false,
            url: api('/sys/sysDictTpDet/getNewDictLev'),
            type: 'GET',
            data: {
              dictTp: context.dictTp,
              treeUp: context.treeUp
            },
            success: function (data) {
              $dlg.find('form');
              $form.formSet(data.data);
            }
          });
        } else {
          $.yvan.ajax({
            loadingMask: false,
            url: api('/sys/sysDictTpDet/getNewDict'),
            type: 'GET',
            data: {
              dictTp: context.dictTp
            },
            success: function (data) {
              $dlg.find('form');
              $form.formSet(data.data);
            }
          });
        }
      },
      center: {
        items: {
          xtype: 'formgroup',
          onRender: function () {
            $form = $(this);
          },
          items: [
            [{name: 'dictId', xtype: 'hidden'}],
            [{name: 'dictTp', xtype: 'hidden'}],
            [{name: 'treeUp', xtype: 'hidden'}],
            [{name: 'treePath', xtype: 'hidden'}],
            [{name: 'treeLev', xtype: 'hidden'}],
            [{name: 'treeCode', label: '字典编号', xtype: 'hidden'}],
            [
              {name: 'dictName', label: '字典名称', required: true, ff: 500, events: {blur: onblurName}},
              {name: 'dictNamePy', label: '拼音', readonly: true}
            ],
            [
              {name: 'dictCode', label: '字典编码', required: true},
              {name: 'dictCodeM', label: '助记码', readonly: true}
            ],
            [
              {name: 'treeSort', label: '序号'},
              {
                name: 'status',
                label: '状态',
                xtype: 'yvselect',
                data: $.yvan.bizDict('status').combo()
              }
            ],
            [{name: 'remark', label: '备注', span: 2, ff: 500, height: '60px', multiline: true}]
          ]
        }
      },
      buttons: [
        {
          text: "提交", iconCls: "fa fa-save", onClick: function () {
            $.yvan.postForm($form, {
              url: (context.isEdit ? api('/sys/sysDictTpDet/update') : api('/sys/sysDictTpDet/insert')),
              success: function () {
                $.yvan.msg('操作成功');
                if (context.isEdit) {
                  $dlg.window('close');
                }
                if ($.type(context.confirm) === 'function') {
                  context.confirm();
                }
              },
              error: function (data) {
              }
            });
          }
        }, {
          text: "关闭", iconCls: "fa fa-times", onClick: function () {
            $dlg.dialog('close');
          }
        }
      ]
    };
  };
});
