define(function (require) {
  return function () {

    var inputParam = Message.getTempParamData();

    // if (inputParam) {
    //   $.yvan.msg('缓存的数据：' + inputParam.sysId);
    // }
    var $grid1, $grid2, $form;

    // 输入搜索文本后点击回车按钮查询列表
    function enterQueryGrid1(e) {
      if (e.keyCode === 13) {
        var tmp = $(this).val();
        $form.formSet({queryProperties: tmp});
        queryGrid1();
      }
    }

    function queryGrid1() {
      if (inputParam) {
        $form.formSet({sysId: inputParam.sysId});
      }
      $grid1.jqGrid("clearGridData");
      $grid1.reload({
        url: api('/sys/sysDictTp/query'),
        mtype: 'POST',
        queryParams: $form.formGet()
      }, true);
      if ($grid2 != undefined) {
        $grid2.jqGrid("clearGridData");
      }
    }

    function queryGrid2(rowid) {
      var row = $grid1.rowData(rowid);
      if (!row) {
        $.yvan.msg('请先选择一行数据');
        return;
      }
      var queryUrl = '/sys/sysDictTpDet/query';// 自行替换此参数
      var queryData = {dictTp: row.dictTp};// 多个参数自行新增
      $grid2.reload({
        mtype: 'POST',
        url: api(queryUrl),
        queryParams: queryData
      });
    }

    //删除
    function deleteRow1() {
      var row = $grid1.rowData();
      if (!row) {
        $.yvan.msg('请先选择一行数据');
        return;
      }
      $.yvan.confirm('确定删除 [' + row.tpName + "] ?", {
        yes: function (index) {
          $.yvan.ajax({
            url: api('/sys/sysDictTp/delete'),
            data: {
              dictTp: row.dictTp,
            },
            method: 'post',
            success: function (data) {
              $.yvan.msg(data.msg);
              $grid1.reload();
              $grid2.reload();
            }
          });
        }
      });
    }

    //删除
    function deleteRow2() {
      var row = $grid2.rowData();
      if (!row) {
        $.yvan.msg('请先选择一行数据');
        return;
      }
      $.yvan.confirm('确定删除 [' + row.dictName + "] ?", {
        yes: function (index) {
          $.yvan.ajax({
            url: api('/sys/sysDictTpDet/delete'),
            data: {
              dictId: row.dictId,
            },
            method: 'post',
            success: function (data) {
              $.yvan.msg(data.msg);
              $grid2.reload();
            }
          });
        }
      });
    }

    //获取平台列表
    function getDataSysList() {
      var _datas = [];
      _datas.push({
        "id": "",
        "text": "全部",
        "selected": true
      });
      _datas.push({
        "id": "0",
        "text": "公共字典"
      });
      $.yvan.ajax({
        url: api('/sys/system/query'),
        data: {status: 1},
        method: 'post',
        async: false,
        success: function (data) {
          if (data.data != null && data.data != undefined) {
            for (var i = 0; i < data.data.length; i++) {
              _datas.push({
                "id": data.data[i].sysId,
                "text": data.data[i].sysName
              })
            }
          }
        }
      });
      return _datas;
    }

    // 搜索按钮
    var queryToolbarTitle = '字典分类管理';// 自行替换此参数
    var queryToolbar = {
      xtype: 'toolbar', title: queryToolbarTitle, items: [
        {
          text: '查询', iconCls: 'fa fa-search', onClick: function () {
            queryGrid1();
          }
        }, {
          text: '重置', iconCls: 'fa fa-refresh', onClick: function () {
            $form.formClear();
            queryGrid1();
          }
        }, {
          text: '关闭', iconCls: 'fa fa-times-circle', onClick: function () {
            App.closeMe(this);
          }
        }
      ]
    };

    // 搜索条件
    var queryFormPrompt = '分类名称/编码/备注';// 自行替换此参数
    var queryForm = {
      onRender: function () {
        $form = $(this);
      },
      xtype: 'form',
      items: [[
        {
          xtype: 'textbox',
          label: '检索条件',
          name: 'queryProperties',
          prompt: queryFormPrompt,
          labelWidth: 'auto',
          events: {keydown: enterQueryGrid1}
        },
        {
          xtype: 'yvselect',
          label: '所属平台',
          name: 'sysId',
          labelWidth: 'auto',
          width: 260,
          data: getDataSysList(),
          onChange: function () {
            queryGrid1();
          }
        },
        {
          xtype: 'yvselect',
          label: '启用状态',
          name: 'status',
          labelWidth: 'auto',
          width: 180,
          data: $.yvan.sysDict('status').combowithAll(),
          onChange: function () {
            queryGrid1();
          }
        }
      ]]
    };

    // 列表1增删改查按钮
    var gridToolbarTitle1 = '字典分类列表';// 自行替换此参数
    var gridToolbar1 = {
      xtype: 'toolbar', title: gridToolbarTitle1, items: [
        {
          text: '新增', iconCls: 'fa fa-plus-circle', onClick: function () {
            var dlg = require('/app/sys/sysDictTp/dialogDictTp.js')({
              isEdit: false,
              confirm: function () {
                $grid1.reload();
              },
              sysId: $form.formGet().sysId
            });
            $.yvan.showDialog(this, dlg);
          }
        },
        {
          text: '编辑', iconCls: 'fa fa-pencil-square-o', onClick: function () {
            var row = $grid1.rowData();
            if (!row) {
              $.yvan.msg('选择一行数据');
              return;
            }
            var dlg = require('/app/sys/sysDictTp/dialogDictTp.js')({
              isEdit: true,
              dictTp: row.dictTp,
              confirm: function () {
                $grid1.reload();
              }
            });
            $.yvan.showDialog(this, dlg);
          }
        },
        {
          text: '删除', iconCls: 'fa fa-trash-o fa-lg', onClick: function () {
            deleteRow1();
          }
        }
      ]
    };

    // 列表2增删改查按钮
    var gridToolbarTitle2 = '字典详情';// 自行替换此参数
    var gridToolbar2 = {
      xtype: 'toolbar', title: gridToolbarTitle2, items: [
        {
          text: '新增', iconCls: 'fa fa-plus-circle', onClick: function () {
            var row1 = $grid1.rowData();
            if (!row1) {
              $.yvan.msg('选择一行数据');
              return;
            }
            var dictTp = row1.dictTp;
            var row2 = $grid2.rowData();
            if (row2) {
              dictTp = row2.dictTp;
            }
            var dlg = require('/app/sys/sysDictTp/dialogDictTpDet.js')({
              isEdit: false,
              dictTp: dictTp,
              confirm: function () {
                $grid1.reload();
              }
            });
            $.yvan.showDialog(this, dlg);
          }
        },
        // {
        //   text: '新增下级', iconCls: 'fa fa-plus-circle', onClick: function () {
        //     var row1 = $grid1.rowData();
        //     if (!row1) {
        //       $.yvan.msg('选择一行数据');
        //       return;
        //     }
        //     var row2 = $grid2.rowData();
        //     if (!row2) {
        //       $.yvan.msg('选择一行数据');
        //       return;
        //     }
        //     if (row2.treeLev == 2) {
        //       $.yvan.msg('无法新增下级');
        //       return;
        //     }
        //     var dlg = require('/app/sys/sysDictTp/dialogDictTpDet.js')({
        //       isEdit: false,
        //       dictTp: row2.dictTp,
        //       treeUp: row2.dictId,
        //       confirm: function () {
        //         $grid1.reload();
        //       }
        //     });
        //     $.yvan.showDialog(this, dlg);
        //   }
        // },
        {
          text: '编辑', iconCls: 'fa fa-pencil-square-o', onClick: function () {
            var row = $grid2.rowData();
            if (!row) {
              $.yvan.msg('选择一行数据');
              return;
            }
            var dlg = require('/app/sys/sysDictTp/dialogDictTpDet.js')({
              isEdit: true,
              dictId: row.dictId,
              confirm: function () {
                $grid1.reload();
              }
            });
            $.yvan.showDialog(this, dlg);
          }
        }, {
          text: '排序', iconCls: 'fa fa-pencil-square-o', onClick: function () {
            var row1 = $grid1.rowData();
            if (!row1) {
              $.yvan.msg('请先选择一行数据');
              return;
            }
            var row2 = $grid2.rowData();
            $.yvan.showDialog(this,
              require('/app/sys/sysDictTp/dialogDictSort.js')({
                confirm: function () {
                  $grid2.reload();
                },
                dictTp: row1.dictTp,
                treeLev: row2.treeLev,
                treeUp: row2.treeUp,
                treeCode: row2.treeCode,
              })
            );
          }
        },
        {
          text: '删除', iconCls: 'fa fa-trash-o fa-lg', onClick: function () {
            deleteRow2();
          }
        }
      ]
    };

    //界面
    return {
      north: {
        height: 90,
        split: true,
        border: false,
        items: [
          queryToolbar,
          queryForm
        ]
      },
      west: {
        width: "50%",
        border: false,
        split: true,
        items: {
          onRender: function () {
            $grid1 = $(this);
            queryGrid1();
          },
          xtype: 'grid',
          toolbar: gridToolbar1,
          pagination: false,
          idField: 'dictTp',
          sortable: true,
          sortname: 'dictTp',
          sortorder: 'asc',
          title: '字典分类列表',
          columns: [[
            //{field: 'dictTp', hidden: true},
            {field: 'dictTp', title: '分类ID',sortable: true,frozen: true, sortorder: 'asc'},//排序打开
            {field: 'tpName', title: '分类名称'},
            {field: 'tpCode', title: '分类编码'},
            {field: 'tpCodeM', title: '分类助记码', hidden: true},
            {field: 'tpNamePy', title: '分类名称拼音', hidden: true},
            {field: 'dictNum', title: '字典数', align: "center"},
            {field: 'status', title: '启用状态', align: "center", formatter: $.fn.fmatter.status},
            {field: 'sysName', title: '所属平台'},
            {field: 'remark', title: '备注'},
            {field: 'timeUpdate', title: '更新时间', formatter: 'ts', hidden: true}
          ]],
          onSelectRow: function (rowid) {
            queryGrid2(rowid);
          },
          loadComplete: function () {
            if ($grid1) {
              $grid1.jqGrid('setFrozenColumns');
              var num = $grid1.records(); //获取当前数据量
              if (num <= 0) {
                if ($grid2) {
                  //清空表格数据
                  $grid2.clearData();
                }
              }
            }
          },
          //排序代码
          onSortCol: function (index, colindex, sortorder) {
            // //注释 index 字段名（field），colindex 当前行首的值，sortorder 排序方式（asc、desc 切换）
            // debugger
          }
        }
      },
      center: {
        width: '50%',
        items: {
          onRender: function () {
            $grid2 = $(this);
          },
          xtype: 'grid',
          toolbar: gridToolbar2,
          pagination: false,
          idField: 'dictId',
          title: '字典信息列表',
          columns: [[
            {field: 'dictId', hidden: true},
            {field: 'dictTp', title: '字典分类ID', hidden: true},
            {field: 'dictName', title: '字典名称', hidden: true},
            {field: 'dictNameView', title: '字典名称', formatter: $.fn.fmatter.treeNameView},// 树结构需要fmatter
            {field: 'dictCode', title: '字典值', align: "center"},
            {field: 'dictCodeM', title: '字典助记码', hidden: true},
            {field: 'dictNamePy', title: '拼音', hidden: true},
            {field: 'treeCode', title: '树编码', hidden: true},
            {field: 'treeUp', title: '上级ID', hidden: true},
            {field: 'treeLev', title: '树级别', hidden: true},
            {field: 'treePath', title: '树路径', hidden: true},
            {field: 'treeSort', title: '树排序', hidden: true},
            {field: 'status', title: '启用状态', align: "center", formatter: $.fn.fmatter.status},
            {field: 'remark', title: '备注'},
            {field: 'userCreate', title: '新增人', hidden: true},
            {field: 'timeCreate', title: '新增时间', formatter: $.fn.fmatter.ts, hidden: true},
            {field: 'userUpdate', title: '修改人', hidden: true},
            {field: 'timeUpdate', title: '修改时间', formatter: $.fn.fmatter.ts, hidden: true}
          ]]
        }
      }
    };
  };
});