define(function (require) {
  return function () {

    var $grid1, $grid2, $form;

    // 输入搜索文本后点击回车按钮查询列表
    function enterQueryGrid1(e) {
      if (e.keyCode === 13) {
        var tmp = $(this).val();
        $form.formSet({queryProperties: tmp});
        queryGrid1();
      }
    }

    //　查询列表
    function queryGrid1() {
      var queryUrl = '/sys/sysRole/query';// 自行替换此参数
      $grid1.jqGrid("clearGridData");
      var queryForm = $form.formGet();
      $grid1.reload({
        mtype: 'POST',
        url: api(queryUrl),
        queryParams: queryForm
      }, true);
      if ($grid2 != undefined) {
        $grid2.jqGrid("clearGridData");
      }
    }

    function queryGrid2(rowid) {
      var row = $grid1.rowData(rowid);
      if (!row) {
        $.yvan.msg('请先选择一行数据');
        return;
      }
      var queryUrl = '/hr/userRole/querySys';// 自行替换此参数
      var queryData = {roleId: row.roleId/*, ownerId: $form.formGet().ownerId*/};// 多个参数自行新增
      $grid2.reload({
        mtype: 'POST',
        url: api(queryUrl),
        queryParams: queryData
      });
    }

    // 更新启停用状态表单1
    function updateStatus() {
      var row = $grid1.rowData();
      if (!row) {
        $.yvan.msg('请先选择一行数据');
        return;
      }
      var obj = {};
      obj.name = row.roleName; //自行替换此参数
      obj.status = row.status;
      obj = setStatusMsg(obj); //返回rtnStatus
      $.yvan.confirm(obj.msg, {
        yes: function (index) {
          $.yvan.ajax({
            method: 'post',
            url: api('/sys/sysRole/updateRoleStatus'),
            data: {
              roleId: row.roleId, //自行替换此参数
              status: obj.rtnStatus //自行替换此参数
            },
            success: function (data) {
              $.yvan.msg(data.msg);
              $grid1.reload();
            }
          });
        }
      });
    }

    //更新检验依据状态表单2
    function updateRoleStatus() {
      var row = $grid2.rowData();
      if (!row) {
        $.yvan.msg('请先选择一行数据');
        return;
      }
      var obj = {};
      obj.name = row.name;
      obj.status = row.status;
      obj = setStatusMsg(obj); //返回rtnStatus
      $.yvan.confirm(obj.msg, {
        yes: function (index) {
          $.yvan.ajax({
            method: 'post',
            url: api("/hr/userRole/updateRoleStatus"),
            data: {
              hurId: row.hurId,// 自行替换此参数
              status: obj.rtnStatus   // 自行替换此参数
            },
            success: function (data) {
              $.yvan.msg(data.msg);
              $grid2.reload();
            }
          });
        }
      });
    }

    //获取平台列表
    function getSysList() {
      var _datas = [];
      _datas.push({'id': '', text: '全部'});
      $.yvan.ajax({
        url: api('/sys/system/query'),
        data: {status: 1},
        method: 'post',
        async: false,
        success: function (data) {
          if (data.data != null && data.data != undefined) {
            for (var i = 0; i < data.data.length; i++) {
              _datas.push({
                "id": data.data[i].sysId,
                "text": data.data[i].sysName
              })
            }
          }
        }
      });
      return _datas;
    }

    // 搜索按钮
    var queryToolbarTitle = '角色管理';// 自行替换此参数
    var queryToolbar = {
      xtype: 'toolbar', title: queryToolbarTitle, items: [
        {
          text: '查询', iconCls: 'fa fa-search', onClick: function () {
            queryGrid1();
          }
        }, {
          text: '重置', iconCls: 'fa fa-refresh', onClick: function () {
            $form.formClear();
            queryGrid1();
          }
        }, {
          text: '关闭', iconCls: 'fa fa-times-circle', onClick: function () {
            App.closeMe(this);
          }
        }
      ]
    };

    // 搜索条件
    var queryFormPrompt = '角色名称/编码';// 自行替换此参数
    var queryForm = {
      onRender: function () {
        $form = $(this);
      },
      xtype: 'form',
      items: [[
        {
          xtype: 'textbox',
          label: '检索条件',
          name: 'queryProperties',
          prompt: queryFormPrompt,
          labelWidth: 'auto',
          events: {keydown: enterQueryGrid1},
        }, {
          xtype: 'yvselect',
          label: '所属平台',
          name: 'sysId',
          labelWidth: 'auto',
          width: 260,
          data: getSysList(),
          onChange: function () {
            queryGrid1();
          }
        }, {
          xtype: 'yvselect', label: '启用状态', name: 'status', labelWidth: 'auto', width: 180, value: '',
          data: $.yvan.sysDict('status').combowithAll(),
          onChange: function () {
            queryGrid1();
          }
        }
      ]]
    };

    // 列表1增删改查按钮
    var gridToolbarTitle1 = '角色列表';// 自行替换此参数
    var gridToolbar1 = {
      xtype: 'toolbar',
      title: gridToolbarTitle1,
      items: [
        {
          text: '新增', iconCls: 'fa fa-plus-circle', onClick: function () {
            $.yvan.showDialog(this,
              require('/app/sys/sysRole/dialogSysRole.js')({
                isEdit: false,
                confirm: function () {
                  $grid1.reload();
                },
                sysId: $form.formGet().sysId,
              })
            );
          }
        }, {
          text: '编辑', iconCls: 'fa fa-pencil-square-o', onClick: function () {
            var row = $grid1.rowData();
            if (!row) {
              $.yvan.msg('请先选择一行数据');
              return;
            }
            $.yvan.showDialog(this,
              require('/app/sys/sysRole/dialogSysRole.js')({
                confirm: function () {
                  $grid1.reload();
                },
                isEdit: true,
                roleId: row.roleId
              })
            );
          }
        }, {
          text: '启用/停用', iconCls: 'fa fa-circle-o-notch', onClick: function () {
            updateStatus();
          }
        }, {
          text: '分配权限', iconCls: 'fa fa-check-square', onClick: function () {
            var row = $grid1.rowData();
            if (!row) {
              $.yvan.msg('请先选择一行数据');
              return;
            }
            $.yvan.showDialog(this,
              require('/app/sys/sysRole/dialogSysRoleMenu.js')({
                confirm: function () {
                  $grid1.reload();
                },
                isEdit: true,
                operation: 1,
                roleId: row.roleId,
                sysId: row.sysId
              })
            );
          }
        }, {
              text: '分配可写权限', iconCls: 'fa fa-check-square', onClick: function () {
                  var row = $grid1.rowData();
                  if (!row) {
                      $.yvan.msg('请先选择一行数据');
                      return;
                  }
                  $.yvan.showDialog(this,
                      require('/app/sys/sysRole/dialogSysRoleMenu.js')({
                          confirm: function () {
                              $grid1.reload();
                          },
                          isEdit: true,
                          operation: 2,
                          roleId: row.roleId,
                          sysId: row.sysId
                      })
                  );
              },
              onRender: function () {
                  $2 = $(this);
                  // $2.closest('.vv').hide();
              },
          }
      ]
    };

    // 列表2增删改查按钮
    var gridToolbarTitle2 = '人员列表';// 自行替换此参数
    var gridToolbar2 = {
      xtype: 'toolbar',
      title: gridToolbarTitle2,
      items: [
        {
          text: '启用/停用', iconCls: 'fa fa-circle-o-notch', onClick: function () {
            updateRoleStatus();
          }
        }
      ]
    };

    return {
      north: {
        height: 90,
        split: true,
        border: false,
        items: [
          queryToolbar,
          queryForm
        ]
      },
      west: {
        width: "60%",
        split: true,
        border: false,
        items: {
          onRender: function () {
            $grid1 = $(this);
          },
          xtype: 'grid',
          pagination: false,
          toolbar: gridToolbar1,
          idField: 'roleId',
          title: '角色列表',
          columns: [[
            {title: '角色ID', field: 'roleId', hidden: true},
            {title: '平台ID', field: 'sysId', hidden: true},
            {title: '角色名称', field: 'roleName'},
            {title: '角色编码', field: 'roleCode'},
            {title: '备注', field: 'remark'},
            {title: '人数', field: 'numUser', align: "right"},
            {title: '菜单数', field: 'numMenu', align: "right"},
            {title: '所属平台', field: 'sysName', hidden: true},
            {title: '状态', field: 'status', hidden: true},
            {title: '启用状态', field: 'statusCN', align: "center", formatter: $.fn.fmatter.statusView},
            {title: '新增时间', field: 'timeCreate', formatter: 'ts', align: "center"},
            {title: '更新时间', field: 'timeUpdate', formatter: 'ts', align: "center"}
          ]],
          onSelectRow: function (rowid) {
            queryGrid2(rowid);
          }
        }
      },
      center: {
        height: '40%',
        items: {
          onRender: function () {
            $grid2 = $(this);
          },
          xtype: 'grid',
          toolbar: gridToolbar2,
          idField: 'hurId',
          title: '人员列表',
          columns: [[
            {title: '账号ID', field: 'hurId', hidden: true},
            {title: '登录账号', field: 'sysId', hidden: true},
            {title: '用户ID', field: 'userId', hidden: true},
            {title: '姓名', field: 'name'},
            {title: '启用状态', field: 'status', hidden: true},
            {title: '启用状态', field: 'statusView', align: "center", formatter: $.fn.fmatter.accountStatusView},
            {title: '新增人', field: 'userCreate', hidden: true},
            {title: '加入时间', field: 'timeCreate', formatter: 'ts', align: "center"},
            {title: '更新人', field: 'userUpdate', hidden: true},
            {title: '更新时间', field: 'timeUpdate', formatter: 'ts', align: "center"}
          ]]
        }
      }
    };
  };
});