define(function (require) {
  return function () {

    var $grid1, $grid2, $form;

    // 输入搜索文本后点击回车按钮查询列表
    function enterQueryGrid1(e) {
      if (e.keyCode === 13) {
        var tmp = $(this).val();
        $form.formSet({queryProperties: tmp});
        queryGrid1();
      }
    }

    //　查询列表
    function queryGrid1() {
      clearGrid($grid1);
      clearGrid($grid2);
      $grid1.reload({
        mtype: 'POST',
        url: api('/sys/sysUnit/query'),
        queryParams: $form.formGet()
      }, true);
    }

    function queryGrid2(rowid) {
      var row = $grid1.rowData(rowid);
      if (!row) {
        $.yvan.msg('请先选择一行数据');
        return;
      }
      clearGrid($grid2);
      //控制分页界面里的数据显示
      var queryUrl = '/sys/sysUnitCv/query';// 自行替换此参数
      var queryData = {unitIdA: row.unitId, unitNameA: row.unitName,};// 多个参数自行新增
      $grid2.reload({
        mtype: 'POST',
        url: api(queryUrl),
        queryParams: queryData
      });
    }

    // 删除
    function deleteRow1() {
      var row = $grid1.rowData();
      if (!row) {
        $.yvan.msg('请先选择一行数据');
        return;
      }
      $.yvan.confirm('确定要删除[' + row.unitName + ']吗?', {
        yes: function (index) {
          $.yvan.ajax({
            method: 'post',
            url: api('/sys/sysUnit/delete'),
            data: {
              unitId: row.unitId,
              flagDel: 1
            },
            success: function (data) {
              $.yvan.msg(data.msg);
              $grid1.reload();
            }
          });
        }
      });
    }

    // 删除
    function deleteRow2() {
      var row = $grid2.rowData();
      if (!row) {
        $.yvan.msg('请先选择一行数据');
        return;
      }
      $.yvan.confirm('确定要删除该单位换算吗?', {
          yes: function (index) {
            $.yvan.ajax({
              method: 'post',
              url: api('/sys/sysUnitCv/delete'),
              data: {
                converId: row.converId,
              },
              success: function (data) {
                $.yvan.msg(data.msg);
                $grid1.reload();
              }
            });
          }
        }
      );
    }

    // 搜索按钮  页面第一行
    var queryToolbarTitle = '物资单位管理';
    var queryToolbar = {
      xtype: 'toolbar', title: queryToolbarTitle, items: [
        {
          text: '查询', iconCls: 'fa fa-search', onClick: function () {
            queryGrid1();
          }
        }, {
          text: '重置', iconCls: 'fa fa-refresh', onClick: function () {
            $form.formClear();
            queryGrid1();
          }
        }, {
          text: '关闭', iconCls: 'fa fa-times-circle', onClick: function () {
            App.closeMe(this);
          }
        }
      ]
    };

    // 搜索条件  页面第二行
    var queryFormPrompt = '单位名称/编码';
    var queryForm = {
      onRender: function () {
        $form = $(this);
      },
      xtype: 'form',
      items: [[
        {
          xtype: 'textbox',
          label: '检索条件',
          name: 'queryProperties',
          prompt: queryFormPrompt,
          labelWidth: 'auto',
          events: {keydown: enterQueryGrid1},
        },
        {
          xtype: 'yvselect', label: '单位类型', name: 'unitType', labelWidth: 'auto', width: 180, value: '',
          data: $.yvan.sysDict('unitType').combowithAll(),
          onChange: function () {
            queryGrid1();
          }
        },
        {
          xtype: 'yvselect', label: '启用状态', name: 'status', labelWidth: 'auto', width: 180, value: '',
          data: $.yvan.sysDict('status').combowithAll(),  //字典值不对应吗
          onChange: function () {
            queryGrid1();
          }
        },
      ]]
    };

    // 列表1增删改查按钮
    var gridToolbarTitle = '单位列表';
    var gridToolbar1 = {
      xtype: 'toolbar', title: gridToolbarTitle,
      items: [
        {
          text: '新增', iconCls: 'fa fa-plus-circle', onClick: function () {
            var dlg = require('/app/sys/sysUnit/dialogSysUnit.js')({// 自行替换此参数
              isEdit: false,
              unitType: $form.formGet().unitType,
              confirm: function () {
                $grid1.reload();
              }
            });
            $.yvan.showDialog(this, dlg);
          }
        }, {
          text: '编辑', iconCls: 'fa fa-pencil-square-o', onClick: function () {
            var row = $grid1.rowData();
            if (!row) {
              $.yvan.msg('请先选择一行数据');
              return;
            }
            var dlg = require('/app/sys/sysUnit/dialogSysUnit.js')({// 自行替换此参数
              isEdit: true,
              unitId: row.unitId,// 自行替换此参数
              unitType: $form.formGet().unitType,
              confirm: function () {
                $grid1.reload();
              }
            });
            $.yvan.showDialog(this, dlg);
          }
        }, {
          text: '单位排序', iconCls: 'fa fa-pencil-square-o', onClick: function () {
            var row = $grid1.rowData();
            if (!row) {
              $.yvan.msg('请先选择一行数据');
              return;
            }
            $.yvan.showDialog(this,
              require('/app/sys/sysUnit/dialogSysUnitSort.js')({
                confirm: function () {
                  $grid1.reload();
                },
                unitType: row.unitType,
              })
            );
          }
        },
        // {
        //   text: '维护', iconCls: 'fa fa-plus-circle', onClick: function () {
        //     var row = $grid1.rowData();
        //     if (!row) {
        //       $.yvan.msg('请先选择一行数据');
        //       return;
        //     }
        //     var dlg = require('/app/sys/sysUnit/dialogUnitConver.js')({// 自行替换此参数
        //       unitA: row.unitId,// 自行替换此参数
        //       unitType: row.unitType,
        //       confirm: function () {
        //         queryGrid1();
        //       }
        //     });
        //     $.yvan.showDialog(this, dlg);
        //   }
        // },
        {
          text: '删除', iconCls: 'fa fa-trash-o fa-lg', onClick: function () {
            deleteRow1();  //调用前面的函数
          }
        }
      ]
    }

    // 列表2增删改查按钮
    var gridToolbarTitle2 = '换算列表';// 自行替换此参数
    var gridToolbar2 = {
      xtype: 'toolbar',
      title: gridToolbarTitle2,
      items: [
        {
          text: '新增', iconCls: 'fa fa-plus-circle', onClick: function () {
            var row = $grid1.rowData();
            if (!row) {
              $.yvan.msg('请选中一条单位信息后,再进行该操作');
              return;
            }
            $.yvan.showDialog(this,
              require('/app/sys/sysUnit/dialogSysUnitConver.js')({
                isEdit: false,
                unitIdA: row.unitId, //imp
                unitType: row.unitType, //imp
                unitNameA: row.unitName, //imp
                confirm: function () {
                  $grid1.reload();
                }
              })
            );
          }
        },
        {
          text: '编辑', iconCls: 'fa fa-pencil-square-o', onClick: function () {
            var row1 = $grid1.rowData();
            if (!row1) {
              $.yvan.msg('请选中一条单位信息后,再进行该操作');
              return;
            }
            var row2 = $grid2.rowData();
            if (!row2) {
              $.yvan.msg('请先选择一行数据');
              return;
            }
            $.yvan.showDialog(this,
              require('/app/sys/sysUnit/dialogSysUnitConver.js')({
                isEdit: true,
                converId: row2.converId,
                unitIdA: row1.unitId, //imp
                unitType: row1.unitType, //imp
                unitNameA: row1.unitName, //imp
                confirm: function () {
                  $grid1.reload();
                }
              })
            );
          }
        },
        {
          text: '删除', iconCls: 'fa fa-trash-o fa-lg', onClick: function () {
            deleteRow2();
          }
        }
      ]
    };

    return {
      north: {
        height: 90,
        split: true,
        border: false,
        items: [
          queryToolbar,
          queryForm
        ]
      },
      west: {
        width: "55%",
        split: true,
        items: {
          onRender: function () {
            $grid1 = $(this);
            queryGrid1();
          },
          xtype: 'grid',
          toolbar: gridToolbar1,
          idField: "unitId",
          title: '单位列表',
          columns: [[
            {title: '单位Id', field: 'unitId', hidden: true},
            {title: '单位类型', field: 'unitType', align: 'center', formatter: $.fn.fmatter.unitType},
            {title: '单位类型', field: 'unitType', hidden: true},
            {title: '单位名称', field: 'unitName'},
            {title: '单位编码', field: 'unitMark'},
            {title: '转换值', field: 'unitVal'},
            {title: '基础单位', field: 'isBase', align: 'center', formatter: $.fn.fmatter.yesOrNo},
            {title: '转换数', field: 'num', align: 'center'},
            {title: '排序', field: 'sort', align: 'center'},
            {title: '启用状态', field: 'status', align: 'center', formatter: $.fn.fmatter.statusView}, //增加字典，显示正常
            {title: '备注', field: 'remark'},
            {title: '新增人', field: 'userCreate', hidden: true},
            {title: '新增时间', field: 'timeCreate', align: 'center', formatter: 'ts'},
            {title: '修改人', field: 'userUpdate', hidden: true},
            {title: '修改时间', field: 'timeUpdate', align: 'center', formatter: 'ts'}, //同步时间
          ]],
          onSelectRow: function (rowid) {
            queryGrid2(rowid);
          }
        }
      },
      center: {
        height: '45%',
        border: false,
        items: {
          onRender: function () {
            $grid2 = $(this);
          },
          xtype: 'grid',
          toolbar: gridToolbar2,
          idField: 'converId',
          title: '换算信息',
          columns: [[
            {title: '换算Id', field: 'converId', hidden: true},
            {title: '数值A', field: 'numa', align: 'center', hidden: true},
            {title: '单位A', field: 'unitNameA', align: 'center', hidden: true},
            {title: '转换值', field: 'numb', align: 'right'},
            {title: '转换单位', field: 'unitNameB', align: 'center'},
          ]]
        }
      }
    };
  };
});