define(function (require) {
  return function (context) {

    var $dlg, $form;

    //生成拼音
    function onblurCustomerName() {
      $('body').item('sysName').textbox('setValue', $(this).val());
      var customerName = $('body').item('sysName').textbox("getValue");
      if (null != customerName && "" != customerName && undefined != customerName) {
        $('body').item('sysNamePy').val(top.pinyin.getFullChars(customerName));
        var pinyin = $('body').item('sysNamePy').val();
        $('body').item('sysNamePy').textbox('setValue', pinyin);
      }
    }

    return {
      xtype: 'dialog',
      dialogId: 'dialogSystem',
      title: '平台信息',
      width: 610,
      height: 350,
      onOpen: function () {
        $dlg = $(this);
        if (context.isEdit) {
          $.yvan.ajax({
            loadingMask: false,
            url: api('/sys/system/getById'),
            type: 'GET',
            data: {
              sysId: context.sysId
            },
            success: function (data) {
              $dlg.find('form');
              $form.formSet(data.data);
            }
          });
        } else {
          $form.formSet({
            status: '1'
          });
        }
      },
      center: {
        items: {
          xtype: 'formgroup',
          onRender: function () {
            $form = $(this);
          },
          items: [
            [
              {name: 'sysId', xtype: 'hidden'},
              {name: 'sysCode', label: '平台编码', required: true, disabled: context.isEdit ? "disabled" : ""},
              {
                name: 'status',
                label: '启用状态',
                xtype: 'yvselect',
                required: true,
                data: $.yvan.bizDict('status').combo()
              }
            ],
            [
              {name: 'sysName', label: '平台名称', required: true, events: {blur: onblurCustomerName}},
              {name: 'sysNamePy', label: '名称拼音', readonly: true}
            ],
            [
              {name: 'sysUrl', label: 'URL地址', width: '560px', required: true, prompt: ':8000/index.html'}
            ],
            [
              {
                name: 'sysDesp', label: '说明', width: '560px', height: '90px', multiline: true
              }
            ]
          ]
        }
      },
      buttons: [
        {
          text: "提交", iconCls: "fa fa-save", onClick: function () {
            $.yvan.postForm($form, {
              url: (context.isEdit ? api('/sys/system/update') : api('/sys/system/insert')),
              success: function () {
                $.yvan.msg('操作成功');
                if (context.isEdit) {
                  $dlg.window('close');
                }
                if ($.type(context.confirm) === 'function') {
                  context.confirm();
                }
              },
              error: function (data) {
              }
            });
          }
        }, {
          text: "关闭", iconCls: "fa fa-times", onClick: function () {
            $dlg.dialog('close');
          }
        }
      ]
    };
  };
});
