define(function (require) {
  return function (context) {

    var $grid, $form;

    // 输入搜索文本后点击回车按钮查询列表
    function enterQueryGrid1(e) {
      if (e.keyCode === 13) {
        var tmp = $(this).val();
        $form.formSet({queryProperties: tmp});
        queryGrid1();
      }
    }

    //　查询列表
    function queryGrid1() {
      var queryUrl = '/sys/system/query';// 自行替换此参数
      $grid.jqGrid("clearGridData");
      var queryForm = $form.formGet();
      $grid.reload({
        mtype: 'POST',
        url: api(queryUrl),
        queryParams: queryForm
      });
    }

    // 更新启用停用状态
    function updateStatus() {
      var row = $grid.rowData();
      if (!row) {
        $.yvan.msg('请先选择一行数据');
        return;
      }
      var obj = {};
      obj.name = row.sysName;// 自行替换此参数
      obj.status = row.status;
      obj.isTree = 0;// 树为1，非树为0
      obj = setStatusMsg(obj); //返回rtnStatus
      var msg = obj.msg;
      var status = obj.rtnStatus;
      /*|-----------------------自行替换start-----------------------*/
      var apiUrl = '/sys/system/updateStatus';// 自行替换此参数
      var apiData = {
        sysId: row.sysId,// 自行替换此参数
        status: status
      };
      /*-----------------------自行替换end-----------------------|*/
      $.yvan.confirm(msg, {
        yes: function (index) {
          $.yvan.ajax({
            method: 'post',
            url: api(apiUrl),
            data: apiData,
            success: function (data) {
              $.yvan.msg(data.msg);
              $grid.reload();
            }
          });
        }
      });
    }

    //检索工具栏
    var queryToolbarTitle = '平台管理';// 自行替换此参数
    var queryToolbar = {
      xtype: 'toolbar', title: queryToolbarTitle, items: [
        {
          text: '查询', iconCls: 'fa fa-search', onClick: function () {
            queryGrid1();
          }
        }, {
          text: '重置', iconCls: 'fa fa-refresh', onClick: function () {
            $form.formClear();
            queryGrid1();
          }
        }, {
          text: '关闭', iconCls: 'fa fa-times-circle', onClick: function () {
            App.closeMe();
          }
        }
      ]
    };

    //检索条件表单
    var queryFormPrompt = '平台名称/编码/说明';// 自行替换此参数
    var queryForm = {
      onRender: function () {
        $form = $(this);
      },
      xtype: 'form',
      items: [[
        {
          xtype: 'textbox',
          label: '检索条件',
          name: 'queryProperties',
          prompt: queryFormPrompt,
          labelWidth: 'auto',
          events: {keydown: enterQueryGrid1}
        }, {
          xtype: 'yvselect', label: '启用状态', name: 'status', labelWidth: 'auto', width: 180, value: '',
          data: $.yvan.sysDict('status').combowithAll(),
          onChange: function () {
            queryGrid1();
          }
        }
      ]]
    };

    //编辑工具栏
    var gridToolbarTitle = '平台列表';// 自行替换此参数
    var gridToolbar = {
      xtype: 'toolbar', title: gridToolbarTitle, items: [
        {
          text: '新增', iconCls: 'fa fa-plus-circle', onClick: function () {
            $.yvan.showDialog(this,
              require('/app/sys/system/dialogSystem.js')({
                confirm: function () {
                  $grid.reload();
                },
                isEdit: false
              })
            );
          }
        }, {
          text: '编辑', iconCls: 'fa fa-pencil-square-o', onClick: function () {
            var row = $grid.rowData();
            if (!row) {
              $.yvan.msg('请先选择一行数据');
              return;
            }
            $.yvan.showDialog(this,
              require('/app/sys/system/dialogSystem.js')({
                confirm: function () {
                  $grid.reload();
                },
                isEdit: true,
                sysId: row.sysId
              })
            );
          }
        }, {
          text: '启用/停用', iconCls: 'fa fa-circle-o-notch', onClick: function () {
            updateStatus();
          }
        }
      ]
    }

    return {
      center: {
        border: false,
        items: {
          onRender: function () {
            $grid = $(this);
            queryGrid1(); //初始化数据
          },
          xtype: 'grid',
          idField: "sysId",
          toolbar: {
            xtype: 'div',
            items: [
              queryToolbar,
              queryForm,
              gridToolbar
            ]
          },
          columns: [[
            {title: '平台ID', field: 'sysId', hidden: true},
            {title: '平台名称', field: 'sysName'},
            {title: '平台编码', field: 'sysCode', align: "center"},
            {title: 'URL地址', field: 'sysUrl'},
            {title: '助记码', field: 'sysCodeM', hidden: true},
            {title: '名称拼音', field: 'sysNamePy', hidden: true},
            {title: '说明', field: 'sysDesp'},
            {title: '状态', field: 'status', hidden: true},
            {title: '启用状态', field: 'statusCN', align: "center", formatter: $.fn.fmatter.statusView},
            {title: '新增时间', field: 'timeCreate', formatter: 'ts', align: "center"},
            {title: '更新时间', field: 'timeUpdate', formatter: 'ts', align: "center"}
          ]]
        }
      }
    };
  };
});
