define(function (require) {
    return function (context) {

      var $dlg;

      return {
        xtype: 'dialog',
        dialogId: 'dialogUser',
        title: context.isEdit ? '新增' : '编辑' + '用户代理',
        width: 400,
        height: 460,
        onOpen: function () {
          console.log('onBeforeClose');
          $dlg = $(this);
          $dlg.formSet(context.row);
        },
        center: {
          items: {
            xtype: 'form',
            items: [
              [{name: 'userAgentId', xtype: 'hidden'}],
              [{name: 'branchId', label: '子机构代码', required: true}],
              [{
                name: 'beActive',
                label: '启用状态',
                required: true,
                xtype: 'yvselect',
                data: [{id: 'Y', text: '启用'}, {id: 'N', text: '禁用'}, {id: 'D', text: '删除'}]
              }],
              [{name: 'loginName', label: '账号', required: true}],
              [{name: 'loginType', label: '登录类型', required: true, xtype: 'yvselect', data: [{id: 'pwd', text: '账号密码'}]}],
              [{name: 'agentType', label: '登录账户类型', required: true}],
              [{name: 'dataId', label: '实体ID', required: true}],
              [{name: 'linkName', label: '显示名称', required: true}],
            ]
          }
        },
        buttons: [
          {
            text: '关闭', iconCls: 'fa fa-times-circle', onClick: function () {
              //关闭方法
              $dlg.window('close');
            }
          },
          {
            text: '保存', iconCls: 'fa fa-save', onClick: function () {
              var newData = $dlg.formGet();
              if (newData.branchId === null || newData.branchId === '') {
                $.yvan.msg('请填写子机构代码');
                return;
              }
              var url = '/sys/userAgent/edit';
              if (context.isEdit === false) {
                url = '/sys/userAgent/add';
              }
              $.yvan.ajax({
                url: api(url),
                contentType: "application/json; charset=utf-8",
                data: JSON.stringify(newData),
                method: 'post',
                success: function (data) {
                  $.yvan.msg(data.msg);
                  $dlg.window('close');
                  context.ok();
                },
                error: function (data) {
                  $.yvan.msg(data.msg);
                }
              });
            }
          }
        ]
      }
    }
  }
);