define(function (require) {
  return function (context) {

    var $grid, $form;

    function queryGrid1() {
      $grid.jqGrid("clearGridData"); // 清除表格数据
      var obj = $form.formGet();
      $grid.reload({
        url: api('/sys/userAgent/query'),
        mtype: 'POST',
        queryParams: obj
      });
    }

    return {
      onRender: function () {
        queryGrid1();
      },
      north: {
        border: false,
        split: true,
        height: 90,
        items: [{
          xtype: 'toolbar',
          title: '用户管理',
          items: [
            {
              text: '查询', iconCls: 'fa fa-search', onClick: function () {
                queryGrid1();
              }
            },
            {
              text: '重置', iconCls: 'fa fa-circle-o-notch', onClick: function () {
                $form.formClear();
                queryGrid1();
              }
            },
            {
              text: '新增', iconCls: 'fa fa-plus-circle', onClick: function () {
                var dlg = require('/app/sys/user/dialogUser.js')({
                  isEdit: false,
                  ok: function () {
                    $grid.reload();
                  }
                });
                $.yvan.showDialog(this, dlg);
              }
            },
            {
              text: '编辑', iconCls: 'fa fa-pencil-square-o', onClick: function () {
                var row = $grid.rowData();
                if (!row) {
                  $.yvan.msg('请选择一行数据');
                }
                var dlg = require('/app/sys/user/dialogUser.js')({
                  isEdit: true,
                  row: row,
                  ok: function () {
                    $grid.reload();
                  }
                });
                $.yvan.showDialog(this, dlg);
              }
            },
            {
              text: '删除', iconCls: 'fa fa-trash-o fa-lg', onClick: function () {
                var row = $grid.rowData();
                if (!row) {
                  $.yvan.msg('请先选择一行数据');
                  return;
                }
                $.yvan.confirm('确定删除[' + row.loginName + "] ?", {
                  yes: function () {
                    $.yvan.ajax({
                      url: api('/sys/userAgent/delete'),
                      data: {
                        userAgentId: row.userAgentId
                      },
                      method: 'post',
                      success: function (data) {
                        $.yvan.msg(data.msg);
                        $grid.reload();
                      },
                      error: function (data) {
                        $.yvan.msg(data.msg);
                      }
                    });
                  }
                });
              }
            },
            {
              text: '关闭', iconCls: 'fa fa-times-circle', onClick: function () {
                App.closeMe();
              }
            }
          ]
        }, {
          xtype: 'form',
          onRender: function () {
            $form = $(this);//
          },
          items: [[
            {name: 'loginType', label: '登录类型', xtype: 'yvselect', data: [{id: 'pwd', text: '账号密码'}]},
            {name: 'loginName', label: '登录账号'},
            {
              name: 'beActive',
              label: '启用状态',
              xtype: 'yvselect',
              data: [{id: 'Y', text: '启用'}, {id: 'N', text: '禁用'}, {id: 'D', text: '删除'}]
            }
          ]]
        }]
      },
      center: {
        border: true,
        split: true,
        items: {
          onRender: function () {
            $grid = $(this);
          },
          xtype: 'tabs',
          onSelect: function (title, index) {
          },
          items: [{
            title: '主信息',
            // lazy: true,
            items: {
              xtype: 'grid',
              toolbar: {
                xtype: 'toolbar',
                title: '用户列表'
              },
              idField: 'userAgentId',
              columns: [[
                {field: 'userAgentId', hidden: true},
                {field: 'branchId', title: '子机构代码'},
                {field: 'loginName', title: '账号'},
                {field: 'loginType', title: '登录类型', formatter: 'lt'},
                {field: 'agentType', title: '登录账户类型'},
                {field: 'dataId', title: '实体ID'},
                {field: 'linkName', title: '显示名称'},
                {field: 'tokenVersion', title: 'token版本号'},
                {field: 'loginCount', title: '登录次数'},
                {field: 'beActive', title: '是否删除', formatter: 'ba'},
                {field: 'lastLoginTime', title: '最后登陆时间', formatter: 'ts'}
              ]]
            }
          }, {
            title: '主信息2',
            onRender: function () {
            },
            // lazy: true,
            items: {
              xtype: 'grid',
              toolbar: {
                xtype: 'toolbar',
                title: '用户列表'
              },
              idField: 'userAgentId',
              columns: [[
                {field: 'userAgentId', hidden: true},
                {field: 'branchId', title: '子机构代码'},
                {field: 'loginName', title: '账号'},
                {field: 'loginType', title: '登录类型', formatter: 'lt'},
                {field: 'agentType', title: '登录账户类型'},
                {field: 'dataId', title: '实体ID'},
                {field: 'linkName', title: '显示名称'},
                {field: 'tokenVersion', title: 'token版本号'},
                {field: 'loginCount', title: '登录次数'},
                {field: 'beActive', title: '是否删除', formatter: 'ba'},
                {field: 'lastLoginTime', title: '最后登陆时间', formatter: 'ts'}
              ]]
            }
          }]
        }
      }
    }
  }
});