define(function (require) {
  return function (context) {

    var $dlg, $form;

    //获取任务列表
    function getTaskList() {
      var _datas = [];
      _datas.push({
        "id": "0",
        "text": "-选择-",
        "selected": true
      });
      $.yvan.ajax({
        url: api('/sys/wfTask/queryAll'),
        data: {status: 1, sysId: context.sysId},
        method: 'get',
        async: false,
        success: function (data) {
          if (data.data != null && data.data != undefined) {
            for (var i = 0; i < data.data.length; i++) {
              _datas.push({
                "id": data.data[i].taskType,
                "text": data.data[i].taskName
              })
            }
          }
        }
      });
      return _datas;
    }

    //获取角色列表
    function getRoleList() {
      var _datas = [];
      _datas.push({
        "id": "0",
        "text": "-选择-",
        "selected": true
      });
      $.yvan.ajax({
        url: api('/sys/sysRole/query'),
        data: {status: 1, sysId: context.sysId},
        method: 'post',
        async: false,
        success: function (data) {
          if (data.data != null && data.data != undefined) {
            for (var i = 0; i < data.data.length; i++) {
              _datas.push({
                "id": data.data[i].roleId,
                "text": data.data[i].roleName
              })
            }
          }
        }
      });
      return _datas;
    }

    //获取菜单列表
    function getMenuList() {
      var _datas = [];
      _datas.push({
        "id": "0",
        "text": "-选择-",
        "selected": true
      });
      $.yvan.ajax({
        url: api('/sys/menu/query'),
        data: {status: 1, sysId: context.sysId},
        method: 'get',
        async: false,
        success: function (data) {
          if (data.data != null && data.data != undefined) {
            for (var i = 0; i < data.data.length; i++) {
              _datas.push({
                "id": data.data[i].menuId,
                "text": data.data[i].menuName
              })
            }
          }
        }
      });
      return _datas;
    }

    return {
      xtype: 'dialog',
      dialogId: 'dialogMenu',
      title: '业务步骤信息',
      width: 610,
      height: 370,
      onOpen: function () {
        $dlg = $(this);
        if (context.stepId > 0) {
          $.yvan.ajax({
            loadingMask: false,
            url: api('/sys/wfStep/getById'),
            type: 'GET',
            data: {
              stepId: context.stepId
            },
            success: function (data) {
              $dlg.find('form');
              $form.formSet(data.data);
            }
          });
        }
        else if (context.treeUp > 0) {
          $.yvan.ajax({
            loadingMask: false,
            url: api('/sys/wfStep/getNewStepUp'),
            type: 'GET',
            data: {
              wfId: context.wfId,
              treeUp: context.treeUp
            },
            success: function (data) {
              $dlg.find('form');
              $form.formSet(data.data);
            }
          });
        } else {
          $.yvan.ajax({
            loadingMask: false,
            url: api('/sys/wfStep/getNewStep'),
            type: 'GET',
            data: {
              wfId: context.wfId
            },
            success: function (data) {
              $dlg.find('form');
              $form.formSet(data.data);
            }
          });
        }
      },
      center: {
        items: {
          xtype: 'formgroup',
          onRender: function () {
            $form = $(this);
          },
          items: [
            [
              {name: 'stepId', xtype: 'hidden'},
              {name: 'wfId', xtype: 'hidden'},
              {name: 'stepUp', xtype: 'hidden'},
              {name: 'treeUp', xtype: 'hidden'},
              {name: 'treePath', xtype: 'hidden'},
              {name: 'stepName', label: '步骤名称', required: true},
              {name: 'stepCode', label: '步骤编码'}
            ],
            [
              {
                name: 'taskType',
                label: '流程任务',
                xtype: 'yvselect',
                panelHeight: 220,
                //disabled: context.isEdit ? "disabled" : context.treeUp > 0 ? "disabled" : "",
                data: getTaskList()
              },
              {
                name: 'status', label: '启用状态', xtype: 'yvselect', required: true, data: [
                  {id: '1', text: '启用', selected: true},
                  {id: '-1', text: '停用'}
                ]
              }
            ],
            [
              {
                name: 'stepRole',
                label: '步骤角色',
                xtype: 'yvselect',
                panelHeight: 220,
                data: getRoleList()
              },
              {
                name: 'menuId',
                label: '步骤菜单',
                xtype: 'yvselect',
                panelHeight: 220,
                data: getMenuList()
              }
            ],
            [
              {name: 'stepDesp', label: '步骤说明', span: 2, height: '90px', multiline: true}
            ]
          ]
        }
      },
      buttons: [
        {
          text: "提交", iconCls: "fa fa-save", onClick: function () {
            $.yvan.postForm($form, {
              url: (context.isEdit ? api('/sys/wfStep/update') : api('/sys/wfStep/insert')),
              success: function () {
                $.yvan.msg('操作成功');
                if (context.isEdit) {
                  $dlg.window('close');
                }
                if ($.type(context.confirm) === 'function') {
                  context.confirm();
                }
              },
              error: function (data) {
              }
            });
          }
        }, {
          text: "关闭", iconCls: "fa fa-times", onClick: function () {
            $dlg.dialog('close');
          }
        }
      ]
    };
  };
});