define(function (require) {
  return function () {

    var $grid1, $grid2, $form;

    // 输入搜索文本后点击回车按钮查询列表
    function enterQueryGrid1(e) {
      if (e.keyCode === 13) {
        var tmp = $(this).val();
        $form.formSet({queryProperties: tmp});
        queryGrid1();
      }
    }

    function queryGrid1() {
      $grid1.reload({
        url: api('/sys/wf/query'),
        mtype: 'GET',
        queryParams: $form.formGet()
      }, true);
      if ($grid2 != undefined) {
        $grid2.jqGrid("clearGridData");
      }
    }

    function queryGrid2(rowid) {
      var row = $grid1.rowData(rowid);
      if (!row) {
        $.yvan.msg('请先选择一行数据');
        return;
      }
      var queryUrl = '/sys/wfStep/query';// 自行替换此参数
      var queryData = {wfId: row.wfId};// 多个参数自行新增
      $grid2.reload({
        mtype: 'GET',
        url: api(queryUrl),
        queryParams: queryData
      });
    }

    //获取平台列表
    function getSysList() {
      var _datas = [];
      _datas.push({
        "id": "",
        "text": "全部",
        "selected": true
      });
      $.yvan.ajax({
        url: api('/sys/system/query'),
        data: {status: 1},
        method: 'post',
        async: false,
        success: function (data) {
          if (data.data != null && data.data != undefined) {
            for (var i = 0; i < data.data.length; i++) {
              _datas.push({
                "id": data.data[i].sysId,
                "text": data.data[i].sysName
              })
            }
          }
        }
      });
      return _datas;
    }

    // 更新启用停用状态
    function updateStatus() {
      var row = $grid1.rowData();
      if (!row) {
        $.yvan.msg('请先选择一行数据');
        return;
      }
      var obj = {};
      obj.name = row.wfName;// 自行替换此参数
      obj.status = row.status;
      obj.isTree = 0;// 树为1，非树为0
      obj = setStatusMsg(obj); //返回rtnStatus
      var msg = obj.msg;
      var status = obj.rtnStatus;
      /*|-----------------------自行替换start-----------------------*/
      var apiUrl = '/sys/wf/updateStatus';// 自行替换此参数
      var apiData = {
        wfId: row.wfId,// 自行替换此参数
        status: status
      };
      /*-----------------------自行替换end-----------------------|*/
      $.yvan.confirm(msg, {
        yes: function (index) {
          $.yvan.ajax({
            method: 'post',
            url: api(apiUrl),
            data: apiData,
            success: function (data) {
              $.yvan.msg(data.msg);
              $grid1.reload();
            }
          });
        }
      });
    }

    // 更新启用停用状态
    function updateStatusStep() {
      var row = $grid2.rowData();
      if (!row) {
        $.yvan.msg('请先选择一行数据');
        return;
      }
      var obj = {};
      obj.name = row.stepName;// 自行替换此参数
      obj.status = row.status;
      obj.isTree = 1;// 树为1，非树为0
      obj = setStatusMsg(obj); //返回rtnStatus
      var msg = obj.msg;
      var status = obj.rtnStatus;
      /*|-----------------------自行替换start-----------------------*/
      var apiUrl = '/sys/wfStep/updateStatus';// 自行替换此参数
      var apiData = {
        stepId: row.stepId,// 自行替换此参数
        status: status
      };
      /*-----------------------自行替换end-----------------------|*/
      $.yvan.confirm(msg, {
        yes: function (index) {
          $.yvan.ajax({
            method: 'post',
            url: api(apiUrl),
            data: apiData,
            success: function (data) {
              $.yvan.msg(data.msg);
              $grid2.reload();
            }
          });
        }
      });
    }

    // 搜索按钮
    var queryToolbarTitle = '业务流程管理';// 自行替换此参数
    var queryToolbar = {
      xtype: 'toolbar', title: queryToolbarTitle, items: [
        {
          text: '查询', iconCls: 'fa fa-search', onClick: function () {
            queryGrid1();
          }
        }, {
          text: '重置', iconCls: 'fa fa-refresh', onClick: function () {
            $form.formClear();
            queryGrid1();
          }
        }, {
          text: '关闭', iconCls: 'fa fa-times-circle', onClick: function () {
            App.closeMe(this);
          }
        }
      ]
    };

    // 搜索条件
    var queryFormPrompt = '任务编码/名称/说明';// 自行替换此参数
    var queryForm = {
      onRender: function () {
        $form = $(this);
      },
      xtype: 'form',
      items: [[
        {
          xtype: 'textbox',
          label: '检索条件',
          name: 'queryProperties',
          prompt: queryFormPrompt,
          labelWidth: 'auto',
          events: {keydown: enterQueryGrid1}
        }, {
          xtype: 'yvselect',
          label: '所属平台',
          name: 'sysId',
          labelWidth: 'auto',
          width: 280,
          data: getSysList(),
          onChange: function () {
            queryGrid1();
          }
        }
      ]]
    };

    // 列表1增删改查按钮
    var gridToolbarTitle1 = '业务流程列表';// 自行替换此参数
    var gridToolbar1 = {
      xtype: 'toolbar', title: gridToolbarTitle1, items: [
        {
          text: '新增', iconCls: 'fa fa-plus-circle', onClick: function () {
            var dlg = require('app/sys/wf/dialogWf.js')({
              isEdit: false,
              confirm: function () {
                $grid1.reload();
              }
            });
            $.yvan.showDialog(this, dlg);
          }
        },
        {
          text: '编辑', iconCls: 'fa fa-pencil-square-o', onClick: function () {
            var row = $grid1.rowData();
            if (!row) {
              $.yvan.msg('选择一行数据');
              return;
            }
            var dlg = require('/app/sys/wf/dialogWf.js')({
              isEdit: true,
              wfId: row.wfId,
              confirm: function () {
                $grid1.reload();
              }
            });
            $.yvan.showDialog(this, dlg);
          }
        }, {
          text: '启用/停用', iconCls: 'fa fa-circle-o-notch', onClick: function () {
            updateStatus();
          }
        }
      ]
    };

    // 列表2增删改查按钮
    var gridToolbarTitle2 = '业务流程步骤列表';// 自行替换此参数
    var gridToolbar2 = {
      xtype: 'toolbar', title: gridToolbarTitle2, items: [
        {
          text: '新增', iconCls: 'fa fa-plus-circle', onClick: function () {
            var sysId = 0, wfId = 0, treeUp = 0;
            var row1 = $grid1.rowData();
            if (!row1) {
              $.yvan.msg('选择一行数据');
              return;
            }
            sysId = row1.sysId;
            wfId = row1.wfId;
            var row2 = $grid2.rowData();
            if (row2) {
              treeUp = row2.treeUp;
            }
            var dlg = require('/app/sys/wf/dialogWfStep.js')({
              isEdit: false,
              sysId: sysId,
              wfId: wfId,
              treeUp: treeUp,
              confirm: function () {
                $grid2.reload();
              }
            });
            $.yvan.showDialog(this, dlg);
          }
        }, {
          text: '新增下级', iconCls: 'fa fa-plus-circle', onClick: function () {
            var row1 = $grid1.rowData();
            if (!row1) {
              $.yvan.msg('选择一行数据');
              return;
            }
            var row2 = $grid2.rowData();
            if (!row2) {
              $.yvan.msg('选择一行数据');
              return;
            }
            if (row2.treeLeaf == 1) {
              $.yvan.msg('无法添加下级');
              return;
            }
            var dlg = require('/app/sys/wf/dialogWfStep.js')({
              isEdit: false,
              sysId: row1.sysId,
              wfId: row1.wfId,
              taskType: row2.taskType,
              treeUp: row2.stepId,
              confirm: function () {
                $grid2.reload();
              }
            });
            $.yvan.showDialog(this, dlg);
          }
        }, {
          text: '编辑', iconCls: 'fa fa-pencil-square-o', onClick: function () {
            var row1 = $grid1.rowData();
            if (!row1) {
              $.yvan.msg('选择一行数据');
              return;
            }
            var row2 = $grid2.rowData();
            if (!row2) {
              $.yvan.msg('选择一行数据');
              return;
            }
            var dlg = require('/app/sys/wf/dialogWfStep.js')({
              isEdit: true,
              sysId: row1.sysId,
              stepId: row2.stepId,
              confirm: function () {
                $grid1.reload();
              }
            });
            $.yvan.showDialog(this, dlg);
          }
        }, {
          text: '同级排序', iconCls: 'fa fa-pencil-square-o', onClick: function () {
            var row1 = $grid1.rowData();
            if (!row1) {
              $.yvan.msg('请先选择一行数据');
              return;
            }
            var row2 = $grid2.rowData();
            $.yvan.showDialog(this,
              require('/app/sys/wf/dialogWfStepSort.js')({
                confirm: function () {
                  $grid2.reload();
                },
                // stepId: row2.stepId,
                wfId: row1.wfId,
                treeLev: row2.treeLev,
                treeUp: row2.treeUp,
                treeCode: row2.treeCode,
              })
            );
          }
        }, {
          text: '启用/停用', iconCls: 'fa fa-circle-o-notch', onClick: function () {
            updateStatusStep();
          }
        }
      ]
    };

    //界面
    return {
      north: {
        height: 90,
        split: true,
        border: false,
        items: [
          queryToolbar,
          queryForm
        ]
      },
      west: {
        width: "50%",
        border: false,
        split: true,
        items: {
          onRender: function () {
            $grid1 = $(this);
            //queryGrid1();
          },
          xtype: 'grid',
          toolbar: gridToolbar1,
          pagination: false,
          idField: 'wfId',
          title: '业务流程列表',
          columns: [[
            {title: '业务流程ID', field: 'wfId', hidden: true},
            {title: '系统ID', field: 'sysId', hidden: true},
            {title: '流程编码', field: 'wfCode'},
            {title: '流程名称', field: 'wfName'},
            {title: '流程说明', field: 'wfDesp'},
            {title: '步骤数', field: 'stepNum', hidden: true},
            {title: '任务种类', field: 'taskNum', hidden: true},
            {title: '启用状态', field: 'status', hidden: true},
            {title: '启用状态', field: 'statusView', align: "center", formatter: $.fn.fmatter.statusView},
            {title: '新增时间', field: 'timeCreate', formatter: 'ts', hidden: true},
            {title: '更新时间', field: 'timeUpdate', formatter: 'ts', hidden: true}
          ]],
          onSelectRow: function (rowid) {
            queryGrid2(rowid);
          }
        }
      },
      center: {
        width: '50%',
        items: {
          onRender: function () {
            $grid2 = $(this);
          },
          xtype: 'grid',
          toolbar: gridToolbar2,
          pagination: false,
          idField: 'stepId',
          title: '业务流程步骤列表',
          columns: [[
            {field: 'stepId', hidden: true},
            {field: 'stepSort', title: '步骤排序', hidden: true},
            {field: 'stepName', title: '步骤名称', hidden: true},
            {field: 'stepNameView', title: '步骤', formatter: $.fn.fmatter.treeNameView},// 树结构需要fmatter
            {field: 'taskType', title: '任务类型', hidden: true},
            {field: 'stepCode', title: '步骤编码'},
            {field: 'taskName', title: '任务类型'},
            {field: 'treeCode', title: '树编码', hidden: true},
            {field: 'treeUp', title: '上级ID', hidden: true},
            {field: 'treeLev', title: '树级别', hidden: true},
            {field: 'treePath', title: '树路径', hidden: true},
            {field: 'treeSort', title: '树排序', hidden: true},
            {field: 'treeLeaf', title: '树叶子', hidden: true},
            {field: 'status', title: '启用状态', hidden: true},
            {field: 'statusView', title: '启用状态', align: "center", formatter: $.fn.fmatter.statusView},
            {field: 'userCreate', title: '新增人', hidden: true},
            {field: 'timeCreate', title: '新增时间', formatter: $.fn.fmatter.ts, hidden: true},
            {field: 'userUpdate', title: '修改人', hidden: true},
            {field: 'timeUpdate', title: '修改时间', formatter: $.fn.fmatter.ts, hidden: true}
          ]]
        }
      }
    };
  };
});