define(function (require) {
  return function (context) {

    var $grid, $form;

    // 输入搜索文本后点击回车按钮查询列表
    function enterQueryGrid1(e) {
      if (e.keyCode === 13) {
        var tmp = $(this).val();
        $form.formSet({queryProperties: tmp});
        queryGrid1();
      }
    }

    //　查询列表
    function queryGrid1() {
      var queryUrl = '/sys/wfStep/query';// 自行替换此参数
      $grid.jqGrid("clearGridData");
      var queryForm = $form.formGet();
      $grid.reload({
        mtype: 'GET',
        url: api(queryUrl),
        queryParams: queryForm
      });
    }

    //获取流程列表
    function getWfList() {
      var _datas = [];
      _datas.push({
        "id": "",
        "text": "全部",
        "selected": true
      });
      $.yvan.ajax({
        url: api('/sys/wf/query'),
        data: {status: 1},
        method: 'get',
        async: false,
        success: function (data) {
          if (data.data != null && data.data != undefined) {
            for (var i = 0; i < data.data.length; i++) {
              _datas.push({
                "id": data.data[i].wfId,
                "text": data.data[i].wfName
              })
            }
          }
        }
      });
      return _datas;
    }

    //获取任务列表
    function getWfTaskList() {
      var _datas = [];
      _datas.push({
        "id": "",
        "text": "全部",
        "selected": true
      });
      $.yvan.ajax({
        url: api('/sys/wfTask/query'),
        data: {status: 1},
        method: 'get',
        async: false,
        success: function (data) {
          if (data.data != null && data.data != undefined) {
            for (var i = 0; i < data.data.length; i++) {
              _datas.push({
                "id": data.data[i].taskType,
                "text": data.data[i].taskName
              })
            }
          }
        }
      });
      return _datas;
    }

    //检索工具栏
    var queryToolbarTitle = '步骤管理';// 自行替换此参数
    var queryToolbar = {
      xtype: 'toolbar', title: queryToolbarTitle, items: [
        {
          text: '查询', iconCls: 'fa fa-search', onClick: function () {
            queryGrid1();
          }
        }, {
          text: '重置', iconCls: 'fa fa-refresh', onClick: function () {
            $form.formClear();
            queryGrid1();
          }
        }, {
          text: '关闭', iconCls: 'fa fa-times-circle', onClick: function () {
            App.closeMe();
          }
        }
      ]
    };

    //检索条件表单
    var queryFormPrompt = '步骤名称/流程名称/任务名称';// 自行替换此参数
    var queryForm = {
      onRender: function () {
        $form = $(this);
      },
      xtype: 'form',
      items: [[
        {
          xtype: 'textbox',
          label: '检索条件',
          name: 'queryProperties',
          prompt: queryFormPrompt,
          labelWidth: 'auto',
          events: {keydown: enterQueryGrid1}
        }, {
          xtype: 'yvselect',
          label: '所属流程',
          name: 'wfId',
          labelWidth: 'auto',
          width: 280,
          data: getWfList(),
          onChange: function () {
            queryGrid1();
          }
        }, {
          xtype: 'yvselect',
          label: '所属任务',
          name: 'taskType',
          labelWidth: 'auto',
          width: 280,
          data: getWfTaskList(),
          onChange: function () {
            queryGrid1();
          }
        }
      ]]
    };

    //编辑工具栏
    var gridToolbarTitle = '业务流程列表';// 自行替换此参数
    var gridToolbar = {
      xtype: 'toolbar', title: gridToolbarTitle, items: [
        {
          text: '维护人员', iconCls: 'fa fa-pencil-square-o', onClick: function () {
            var row = $grid.rowData();
            if (!row) {
              $.yvan.msg('请先选择一行数据');
              return;
            }
            $.yvan.showDialog(this,
              require('/app/sys/wf/dialogWfStepUser.js')({  // 自行替换此参数
                confirm: function () {
                  $grid.reload();
                },
                isEdit: true,
                stepId: row.stepId     // 自行替换此参数
              })
            );
          }
        }, {
          text: '维护步骤判定', iconCls: 'fa fa-pencil-square-o', onClick: function () {
            var row = $grid.rowData();
            if (!row) {
              $.yvan.msg('请先选择一行数据');
              return;
            }
            $.yvan.showDialog(this,
              require('/app/sys/wf/dialogWfStepJudge.js')({  // 自行替换此参数
                confirm: function () {
                  $grid.reload();
                },
                isEdit: true,
                stepId: row.stepId     // 自行替换此参数
              })
            );
          }
        }
      ]
    }

    return {
      center: {
        border: false,
        items: {
          onRender: function () {
            $grid = $(this);
            queryGrid1(); //初始化数据
          },
          xtype: 'grid',
          idField: "wfId",
          toolbar: {
            xtype: 'div',
            items: [
              queryToolbar,
              queryForm,
              gridToolbar
            ]
          },
          columns: [[
            {title: '业务流程ID', field: 'wfId', hidden: true},
            {title: '流程编码', field: 'wfCode'},
            {title: '流程名称', field: 'wfName'},
            {title: '流程说明', field: 'wfDesp'},
            {title: '所属平台', field: 'sysName'},
            {title: '步骤数', field: 'stepNum'},
            {title: '任务种类', field: 'taskNum'},
            {title: '状态', field: 'status', hidden: true},
            {title: '启用状态', field: 'statusView', formatter: $.fn.fmatter.statusView},
            {title: '新增时间', field: 'timeCreate', formatter: 'ts'},
            {title: '更新时间', field: 'timeUpdate', formatter: 'ts'}
          ]]
        }
      }
    };
  };
});
