define(function (require) {
  return function (context) {

    var $grid, $form;

    // 输入搜索文本后点击回车按钮查询列表
    function enterQueryGrid1(e) {
      if (e.keyCode === 13) {
        var tmp = $(this).val();
        $form.formSet({queryProperties: tmp});
        queryGrid1();
      }
    }

    //　查询列表
    function queryGrid1() {
      var queryUrl = '/sys/wfTask/query';// 自行替换此参数
      $grid.jqGrid("clearGridData");
      var queryForm = $form.formGet();
      $grid.reload({
        mtype: 'GET',
        url: api(queryUrl),
        queryParams: queryForm
      });
    }

    // 更新启用停用状态
    function updateStatus() {
      var row = $grid.rowData();
      if (!row) {
        $.yvan.msg('请先选择一行数据');
        return;
      }
      var obj = {};
      obj.name = row.taskName;// 自行替换此参数
      obj.status = row.status;
      obj.isTree = 0;// 树为1，非树为0
      obj = setStatusMsg(obj); //返回rtnStatus
      var msg = obj.msg;
      var status = obj.rtnStatus;
      /*|-----------------------自行替换start-----------------------*/
      var apiUrl = '/sys/wfTask/updateStatus';// 自行替换此参数
      var apiData = {
        taskType: row.taskType,// 自行替换此参数
        status: status
      };
      /*-----------------------自行替换end-----------------------|*/
      $.yvan.confirm(msg, {
        yes: function (index) {
          $.yvan.ajax({
            method: 'post',
            url: api(apiUrl),
            data: apiData,
            success: function (data) {
              $.yvan.msg(data.msg);
              $grid.reload();
            }
          });
        }
      });
    }

    //获取平台列表
    function getDataSysList() {
      var _datas = [];
      _datas.push({
        "id": "",
        "text": "全部",
        "selected": true
      });
      $.yvan.ajax({
        url: api('/sys/system/query'),
        data: {status: 1},
        method: 'post',
        async: false,
        success: function (data) {
          if (data.data != null && data.data != undefined) {
            for (var i = 0; i < data.data.length; i++) {
              _datas.push({
                "id": data.data[i].sysId,
                "text": data.data[i].sysName
              })
            }
          }
        }
      });
      return _datas;
    }

    //检索工具栏
    var queryToolbarTitle = '业务流程管理';// 自行替换此参数
    var queryToolbar = {
      xtype: 'toolbar', title: queryToolbarTitle, items: [
        {
          text: '查询', iconCls: 'fa fa-search', onClick: function () {
            queryGrid1();
          }
        }, {
          text: '重置', iconCls: 'fa fa-refresh', onClick: function () {
            $form.formClear();
            queryGrid1();
          }
        }, {
          text: '关闭', iconCls: 'fa fa-times-circle', onClick: function () {
            App.closeMe();
          }
        }
      ]
    };

    //检索条件表单
    var queryFormPrompt = '任务名称/编码/说明';// 自行替换此参数
    var queryForm = {
      onRender: function () {
        $form = $(this);
      },
      xtype: 'form',
      items: [[
        {
          xtype: 'textbox',
          label: '检索条件',
          name: 'queryProperties',
          prompt: queryFormPrompt,
          labelWidth: 'auto',
          events: {keydown: enterQueryGrid1}
        }, {
          xtype: 'yvselect',
          label: '所属平台',
          name: 'sysId',
          labelWidth: 'auto',
          width: 280,
          data: getDataSysList(),
          onChange: function () {
            queryGrid1();
          }
        }, {
          xtype: 'yvselect', label: '启用状态', name: 'status', labelWidth: 'auto', width: 180, value: '',
          data: $.yvan.sysDict('status').combowithAll(),
          onChange: function () {
            queryGrid1();
          }
        }
      ]]
    };

    //编辑工具栏
    var gridToolbarTitle = '业务流程列表';// 自行替换此参数
    var gridToolbar = {
      xtype: 'toolbar', title: gridToolbarTitle, items: [
        {
          text: '新增', iconCls: 'fa fa-plus-circle', onClick: function () {
            $.yvan.showDialog(this,
              require('/app/sys/wf/dialogWfTask.js')({  // 自行替换此参数
                confirm: function () {
                  $grid.reload();
                },
                isEdit: false,
                sysId: $form.formGet().sysId,
              })
            );
          }
        }, {
          text: '编辑', iconCls: 'fa fa-pencil-square-o', onClick: function () {
            var row = $grid.rowData();
            if (!row) {
              $.yvan.msg('请先选择一行数据');
              return;
            }
            $.yvan.showDialog(this,
              require('/app/sys/wf/dialogWfTask.js')({  // 自行替换此参数
                confirm: function () {
                  $grid.reload();
                },
                isEdit: true,
                sysId: row.sysId,
                taskType: row.taskType     // 自行替换此参数
              })
            );
          }
        }, {
          text: '启用/停用', iconCls: 'fa fa-circle-o-notch', onClick: function () {
            updateStatus();
          }
        }
      ]
    }

    return {
      center: {
        border: false,
        items: {
          onRender: function () {
            $grid = $(this);
            //queryGrid1(); //初始化数据
          },
          xtype: 'grid',
          idField: "taskType",
          toolbar: {
            xtype: 'div',
            items: [
              queryToolbar,
              queryForm,
              gridToolbar
            ]
          },
          columns: [[
            {title: '任务类型', field: 'taskType', hidden: true},
            {title: '任务名称', field: 'taskName'},
            {title: '任务编码', field: 'taskCode'},
            {title: '对应表格', field: 'taskTable', hidden: true},
            {title: '处理角色', field: 'roleName'},
            {title: '平台ID', field: 'sysId', hidden: true},
            {title: '所属平台', field: 'sysName', hidden: true},
            {title: '任务说明', field: 'taskDesp'},
            {title: '状态', field: 'status', hidden: true},
            {title: '启用状态', field: 'statusView', align: "center", formatter: $.fn.fmatter.statusView},
            {title: '新增时间', field: 'timeCreate', formatter: 'ts', align: "center"},
            {title: '更新时间', field: 'timeUpdate', formatter: 'ts', align: "center"}
          ]]
        }
      }
    };
  };
});
