define(function (require) {
    return function () {

      var $grid1, $grid2, $form;

      // 输入搜索文本后点击回车按钮查询列表1
      function enterQueryGrid1(e) {
        if (e.keyCode === 13) {
          var tmp = $(this).val();
          $form.formSet({queryProperties: tmp});
          queryGrid1();
        }
      }

      // 查询列表1
      function queryGrid1() {
        var queryUrl = '/bas/corp/query';// 自行替换此参数
        $grid1.jqGrid("clearGridData");
        var queryForm = $form.formGet();
        queryForm.corpType = CORP_TYPE_供应商;
        $grid1.reload({
          mtype: 'POST',
          url: api(queryUrl),
          queryParams: queryForm
        }, true);
      }

      // 根据列表1行数据查询列表2
      function queryGrid2(rowid) {
        var row = $grid1.rowData(rowid);
        if (!row) {
          $.yvan.msg('请先选择一行数据');
          return;
        }
        var queryUrl = '/bas/corpUser/query';// 自行替换此参数
        var queryData = {corpId: row.corpId/*, ownerId: $form.formGet().ownerId*/};// 多个参数自行新增
        $grid2.reload({
          mtype: 'POST',
          url: api(queryUrl),
          queryParams: queryData
        });
      }

      function getLevList() {
        var _datas = [];
        _datas.push({
          "id": '',
          "text": '全部'
        });
        $.yvan.ajax({
          url: api('/bas/corp/queryLev'),
          data: {},
          method: 'post',
          async: false,
          success: function (data) {
            if (data.data != null && data.data != undefined) {
              for (var i = 0; i < data.data.length; i++) {
                _datas.push({
                  "id": data.data[i], "text": data.data[i]
                });
              }
            }
          }
        });
        return _datas;
      }

      // 搜索按钮
      var queryToolbarTitle = '供应商管理';// 自行替换此参数
      var queryToolbar = {
        xtype: 'toolbar', title: queryToolbarTitle, items: [
          {
            text: '查询', iconCls: 'fa fa-search', onClick: function () {
              queryGrid1();
            }
          }, {
            text: '重置', iconCls: 'fa fa-refresh', onClick: function () {
              $form.formClear();
              queryGrid1();
            }
          }, {
            text: '关闭', iconCls: 'fa fa-times-circle', onClick: function () {
              App.closeMe(this);
            }
          }
        ]
      };

      // 搜索条件
      var queryFormPrompt = '供应商名称/联系人/联系电话';// 自行替换此参数
      var queryForm = {
        onRender: function () {
          $form = $(this);
        },
        xtype: 'form',
        items: [[
          {
            xtype: 'textbox',
            label: '检索条件',
            name: 'queryProperties',
            prompt: queryFormPrompt,
            labelWidth: 'auto',
            events: {keydown: enterQueryGrid1},
          },
          // {
          //   xtype: 'yvselect', label: '分级', name: 'lev', labelWidth: 'auto', width: 180,
          //   data: getLevList(),
          //   onChange:
          //     function () {
          //       $grid2.jqGrid("clearGridData");
          //       queryGrid1();
          //     }
          // }
        ]]
      };

      // 列表1增删改查按钮
      var gridToolbarTitle1 = '供应商列表';// 自行替换此参数
      var gridToolbar1 = {
        xtype: 'toolbar',
        title: gridToolbarTitle1,
      };

      // 列表2增删改查按钮
      var gridToolbarTitle2 = '供应商用户列表';// 自行替换此参数
      var gridToolbar2 = {
        xtype: 'toolbar',
        title: gridToolbarTitle2,
      };

      return {
        north: {
          height: 90,
          split: true,
          border: false,
          items: [
            queryToolbar,
            queryForm
          ]
        },
        west: {
          width: "60%",
          border: false,
          split: true,
          items: {
            onRender: function () {
              $grid1 = $(this);
              queryGrid1();
            },
            xtype: 'grid',
            toolbar: gridToolbar1,
            idField: 'corpId',
            title: '供应商列表',
            columns: [[
              {field: 'corpId', hidden: true},
              {title: '供应商名称', field: 'corpName', hidden: true},
              {title: '内部机构ID', field: 'orgId', hidden: true},
              {title: '内部机构', field: 'orgName', hidden: true},
              {title: '供应商编码', field: 'corpCode', hidden: true},
              {title: '供应商条码', field: 'corpBar', hidden: true},
              {title: '供应商社会唯一码', field: 'corpSn', hidden: true},
              {title: '供应商简称', field: 'corpNameSn', hidden: true},
              {title: '供应商英文名', field: 'corpNameEn', hidden: true},
              {title: '供应商名称拼音', field: 'corpNamePy', hidden: true},
              {title: '供应商介绍', field: 'corpDesp', hidden: true},
              {title: '联系邮箱', field: 'linkEmail', hidden: true},
              {title: '联系地址', field: 'linkAddress', hidden: true},
              {title: '邮政编码', field: 'linkZipcode', hidden: true},
              {title: '所在国家', field: 'regCountry', hidden: true},
              {title: '所在国家', field: 'regCode', hidden: true},
              {title: '所在省份', field: 'regProv', hidden: true},
              {title: '所在城市', field: 'regCity', hidden: true},
              {title: '所在乡镇', field: 'regCounty', hidden: true},
              {title: '备注', field: 'remark', hidden: true},
              {title: '状态', field: 'status', hidden: true},
              {title: '树上级ID', field: 'treeUp', hidden: true},
              {title: '上级企业', field: 'treeUpName', hidden: true},
              {title: '树级别', field: 'treeLev', hidden: true},
              {title: '树路径', field: 'treePath', hidden: true},
              {title: '树编码', field: 'treeCode', hidden: true},
              {title: '树排序', field: 'treeSort', hidden: true},
              {title: '新增人', field: 'userCreate', hidden: true},
              {title: '更新人', field: 'Update', hidden: true},
              {title: '供应商名称', field: 'corpNameView', formatter: $.fn.fmatter.treeNameView},// 树结构需要fmatter
              {
                title: '类型', field: 'orgIdCN', align: 'center', formatter: function (value, data) {
                  if (isNotNull(data) && isNotNull(data.rowData) && isNotNull(data.rowData.orgId)) {
                    if ("0" == data.rowData.orgId || "" == data.rowData.orgId) {
                      return "外部";
                    }
                    else {
                      return "<span style='color: green;'>内部</span>";
                    }
                  }
                }
              },
              {title: '分级', field: 'lev', hidden: true},
              {title: '工厂代号', field: 'nickName', hidden: true},
              {title: '隶属关系', field: 'oldName', hidden: true},
              {title: '主供产品', field: 'mainProduct', hidden: true},
              {title: '联系人', field: 'linkMan'},
              {title: '联系电话', field: 'linkTel'},
              {title: '人数', field: 'numUser', align: 'right'},
            ]],
            onSelectRow: function (rowid) {
              queryGrid2(rowid);
            }
          }
        },
        center: {
          width: '40%',
          border: true,
          items: {
            onRender: function () {
              $grid2 = $(this);
            },
            xtype: 'grid',
            toolbar: gridToolbar2,
            idField: 'bcuId',
            title: '供应商用户列表',
            pagination: false,
            columns: [[
              {field: 'bcuId', hidden: true},
              {field: 'corpId', hidden: true},
              {title: '姓名', field: 'name'},
              {title: '性别', field: 'gender', formatter: $.fn.fmatter.genderSrc, align: 'center'},
              {title: '联系电话', field: 'tel'},
              {title: '电子邮箱', field: 'email'},
              {title: '所在部门', field: 'dept'},
              {title: '通讯地址', field: 'address'},
            ]]
          }
        }
      };
    };
  }
);