define(function (require) {
  return function (context) {

    var $grid, $form;

    // 输入搜索文本后点击回车按钮查询列表
    function enterQueryGrid1(e) {
      if (e.keyCode === 13) {
        var tmp = $(this).val();
        $form.formSet({queryProperties: tmp});
        queryGrid1();
      }
    }

    //　查询列表
    function queryGrid1() {
      var queryUrl = '/wms/farmUser/queryFarmUserRole';// 自行替换此参数
      $grid.jqGrid("clearGridData");
      var queryForm = $form.formGet();
      $grid.reload({
        mtype: 'POST',
        url: api(queryUrl),
        queryParams: queryForm
      });
    }

    //获取库区列表
    function getFarmList() {
      var _datas = [];
      _datas.push({
        "id": '',
        "text": '全部'
      })
      $.yvan.ajax({
        url: api('/wms/whFarm/queryAll'),
        method: 'post',
        async: false,
        success: function (data) {
          if (data.data != null && data.data != undefined) {
            for (var i = 0; i < data.data.length; i++) {
              _datas.push({
                "id": data.data[i].farmId,
                "text": data.data[i].farmName
              })
            }
          }
        }
      });
      return _datas;
    }

    //获取角色列表
    function getRoleList() {
      var _datas = [];
      _datas.push({
        "id": "",
        "text": "全部"
      });
      $.yvan.ajax({
        url: api('/wms/farmUser/queryRoleUserCount'),
        method: 'post',
        async: false,
        success: function (data) {
          if (data.data != null && data.data != undefined) {
            for (var i = 0; i < data.data.length; i++) {
              _datas.push({
                "id": data.data[i].roleId,
                "text": data.data[i].roleName
              })
            }
          }
        }
      });
      return _datas;
    }

    // 搜索按钮
    var queryToolbarTitle = '库区人员查询';
    var queryToolbar = {
      xtype: 'toolbar', title: queryToolbarTitle, items: [
        {
          text: '查询', iconCls: 'fa fa-search', onClick: function () {
            queryGrid1();
          }
        }, {
          text: '重置', iconCls: 'fa fa-refresh', onClick: function () {
            $form.formClear();
            queryGrid1();
          }
        }, {
          text: '关闭', iconCls: 'fa fa-times-circle', onClick: function () {
            App.closeMe(this);
          }
        }
      ]
    };

    // 搜索条件
    var queryFormPrompt = '姓名/联系电话';
    var queryForm = {
      onRender: function () {
        $form = $(this);
      },
      xtype: 'form',
      items: [[
        {
          xtype: 'textbox',
          label: '检索条件',
          name: 'queryProperties',
          prompt: queryFormPrompt,
          labelWidth: 'auto',
          events: {keydown: enterQueryGrid1},
        },
        {
          xtype: 'yvselect', label: '库区', name: 'farmId', labelWidth: 'auto', width: 200,
          data: getFarmList(),
          onChange: function () {
            queryGrid1();
          }
        },
        {
          xtype: 'yvselect', label: '角色', name: 'roleId', labelWidth: 'auto', width: 220, panelHeight: 220,
          data: getRoleList(),
          onChange: function () {
            queryGrid1();
          }
        },
      ]]
    };

    // 列表增删改查按钮
    var gridToolbarTitle = '人员列表';
    var gridToolbar = {
      xtype: 'toolbar', title: gridToolbarTitle,
      items: []
    }

    return {
      center: {
        border: false,
        items: {
          onRender: function () {
            $grid = $(this);
            queryGrid1();
          },
          xtype: 'grid',
          idField: "wwuId",
          toolbar: {
            xtype: 'div',
            items: [
              queryToolbar,
              queryForm,
              gridToolbar
            ]
          },
          columns: [[
            {field: 'wwu_id', hidden: true},
            {title: '库区', field: 'farmName', align: 'center'},
            {title: '角色', field: 'roleName'},
            {title: '姓名', field: 'name'},
            {title: '性别', field: 'gender', align: 'center', formatter: $.fn.fmatter.genderSrc},
            {title: '联系电话', field: 'mobile'},
          ]]
        }
      }
    };
  };
});