define(function (require) {
    return function () {

      var $grid1, $grid2, $form;

      // 输入搜索文本后点击回车按钮查询列表1
      function enterQueryGrid1(e) {
        if (e.keyCode === 13) {
          var tmp = $(this).val();
          $form.formSet({queryProperties: tmp});
          queryGrid1();
        }
      }

      function queryGrid1() {
        var queryUrl = '/hr/org/query';// 自行替换此参数
        $grid1.jqGrid("clearGridData");
        var queryForm = $form.formGet();
        $grid1.reload({
          mtype: 'POST',
          url: api(queryUrl),
          queryParams: queryForm
        }, true);
        if ($grid2 != undefined) {
          $grid2.jqGrid("clearGridData");
        }
      }

      function queryGrid2(rowid) {
        var row = $grid1.rowData(rowid);
        if (!row) {
          $.yvan.msg('请先选择一行数据');
          return;
        }
        var queryUrl = '/hr/deptUser/query';// 自行替换此参数
        var queryData = {deptId: row.orgId};// 多个参数自行添加
        $grid2.reload({
          mtype: 'POST',
          url: api(queryUrl),
          queryParams: queryData
        });
      }

      // 搜索按钮
      var queryToolbarTitle = '组织机构查询';// 自行替换此参数
      var queryToolbar = {
        xtype: 'toolbar', title: queryToolbarTitle, items: [
          {
            text: '查询', iconCls: 'fa fa-search', onClick: function () {
              queryGrid1();
            }
          }, {
            text: '重置', iconCls: 'fa fa-refresh', onClick: function () {
              $form.formClear();
              queryGrid1();
            }
          }, {
            text: '关闭', iconCls: 'fa fa-times-circle', onClick: function () {
              App.closeMe(this);
            }
          }
        ]
      };

      // 搜索条件
      var queryFormPrompt = '机构名称/编码/助记码';// 自行替换此参数
      var queryForm = {
        onRender: function () {
          $form = $(this);
        },
        xtype: 'form',
        items: [[
          {
            xtype: 'textbox',
            label: '检索条件',
            name: 'queryProperties',
            prompt: queryFormPrompt,
            labelWidth: 'auto',
            events: {keydown: enterQueryGrid1},
          }, {
            xtype: 'yvselect', label: '是否机构', name: 'isOrg', labelWidth: 'auto', width: 180, value: '',
            data: $.yvan.sysDict('yesOrNo').combowithAll(),
            onChange: function () {
              queryGrid1();
            }
          }, {
            xtype: 'yvselect', label: '是否部门', name: 'isDept', labelWidth: 'auto', width: 180, value: '',
            data: $.yvan.sysDict('yesOrNo').combowithAll(),
            onChange: function () {
              queryGrid1();
            }
          }, {
            xtype: 'yvselect', label: '启用状态', name: 'status', labelWidth: 'auto', width: 180, value: '',
            data: $.yvan.sysDict('status').combowithAll(),
            onChange: function () {
              queryGrid1();
            }
          }
        ]]
      };

      // 列表1增删改查按钮
      var gridToolbarTitle1 = '组织机构列表';// 自行替换此参数
      var gridToolbar1 = {
        xtype: 'toolbar',
        title: gridToolbarTitle1,
      };

      // 列表2增删改查按钮
      var gridToolbarTitle2 = '机构用户列表';// 自行替换此参数
      var gridToolbar2 = {
        xtype: 'toolbar',
        title: gridToolbarTitle2,
      };

      return {
        north: {
          height: 90,
          split: true,
          border: false,
          items: [
            queryToolbar,
            queryForm
          ]
        },
        west: {
          width: "60%",
          border: false,
          split: true,
          items: {
            onRender: function () {
              $grid1 = $(this);
              queryGrid1();
            },
            xtype: 'grid',
            toolbar: gridToolbar1,
            idField: 'orgId',
            title: '组织机构列表',
            columns: [[
              {title: '机构ID', field: 'orgId', hidden: true},
              {title: '机构名称', field: 'orgName', hidden: true},
              {title: '机构名称', field: 'orgNameView', formatter: $.fn.fmatter.treeNameView},// 树结构需要fmatter
              {title: '机构编码', field: 'orgCode', hidden: true},
              {title: '助记码', field: 'orgCodeM', hidden: true},
              {title: '机构名称简称', field: 'orgNameSn'},
              {title: '机构名称拼音', field: 'orgNamePy', hidden: true},
              {title: '树上级ID', field: 'treeUp', hidden: true},
              {title: '上级机构', field: 'treeUpName'},
              {title: '树级别', field: 'treeLev', hidden: true},
              {title: '树路径', field: 'treePath', hidden: true},
              {title: '树编码', field: 'treeCode', hidden: true},
              {title: '树排序', field: 'treeSort', hidden: true},
              {title: '联系人', field: 'linkMan'},
              {title: '联系电话', field: 'linkTel'},
              {title: '是否机构', field: 'isOrg', align: "center", formatter: $.fn.fmatter.yesOrNoSrc},
              {title: '是否部门', field: 'isDept', align: "center", formatter: $.fn.fmatter.yesOrNoSrc},
              {title: '联系人', field: 'linkMan', hidden: true},
              {title: '联系电话', field: 'linkTel', hidden: true},
              {title: '备注', field: 'remark', hidden: true},
              {title: '状态', field: 'status', hidden: true},
              {title: '启用状态', field: 'statusView', align: "center", formatter: $.fn.fmatter.statusView},
              {title: '人员统计', field: 'numUser', align: "right"},
            ]],
            onSelectRow: function (rowid) {
              queryGrid2(rowid);
            }
          }
        },
        center: {
          width: '40%',
          border: true,
          items: {
            onRender: function () {
              $grid2 = $(this);
            },
            xtype: 'grid',
            toolbar: gridToolbar2,
            idField: 'hduId',
            title: '机构用户列表',
            pagination: false,
            columns: [[
              {field: 'hduId', hidden: true},
              {field: 'deptId', hidden: true},
              {field: 'userId', hidden: true},
              {title: '姓名', field: 'name'},
              {title: '性别', field: 'gender', formatter: $.fn.fmatter.genderSrc, align: 'center'},
              {title: '联系电话', field: 'tel'},
            ]]
          }
        }
      };
    };
  }
);