define(function (require) {
  return function (context) {

    var $grid, $form;

    // 输入搜索文本后点击回车按钮查询列表
    function enterQueryGrid1(e) {
      if (e.keyCode === 13) {
        var tmp = $(this).val();
        $form.formSet({queryProperties: tmp});
        queryGrid1();
      }
    }

    //　查询列表
    function queryGrid1() {
      var queryUrl = '/pms/pmsPgh/query';// 自行替换此参数
      $grid.jqGrid("clearGridData");
      var queryForm = $form.formGet();
      $grid.reload({
        mtype: 'POST',
        url: api(queryUrl),
        queryParams: queryForm
      });
    }

    // 搜索按钮
    var queryToolbarTitle = '派工号管理';
    var queryToolbar = {
      xtype: 'toolbar', title: queryToolbarTitle, items: [
        {
          text: '查询', iconCls: 'fa fa-search', onClick: function () {
            queryGrid1();
          }
        }, {
          text: '重置', iconCls: 'fa fa-refresh', onClick: function () {
            $form.formClear();
            queryGrid1();
          }
        }, {
          text: '关闭', iconCls: 'fa fa-times-circle', onClick: function () {
            App.closeMe(this);
          }
        }
      ]
    };

    // 搜索条件
    var queryFormPrompt = '派工号/送修单位/机尾号';
    var queryForm = {
      onRender: function () {
        $form = $(this);
      },
      xtype: 'form',
      items: [[
        {
          xtype: 'textbox',
          label: '检索条件',
          name: 'queryProperties',
          prompt: queryFormPrompt,
          labelWidth: 'auto',
          events: {keydown: enterQueryGrid1},
        },
        {
          xtype: 'yvselect', label: '维修类别', name: 'mfLev', labelWidth: 'auto', width: 180,
          data: $.yvan.sysDict('mfLev').combowithAll(), value: '',
          onChange: function () {
            queryGrid1();
          }
        },
        {
          xtype: 'yvselect', label: '发布状态', name: 'status', labelWidth: 'auto', width: 180,
          data: $.yvan.sysDict('statusPub').combowithAll(), value: '',
          onChange: function () {
            queryGrid1();
          }
        },
      ]]
    };

    // 列表增删改查按钮
    var gridToolbarTitle = '派工号列表';
    var gridToolbar = {
      xtype: 'toolbar', title: gridToolbarTitle,
      items: [
        {
          text: '预览', iconCls: 'fa fa-sticky-note-o', onClick: function () {
            var row = $grid.rowData();
            if (!row) {
              $.yvan.msg('请先选择一行数据');
              return;
            }
            var dlg = require('/app/pms/pgh/viewDialogPgh.js')({// 自行替换此参数
              isEdit: true,
              pghId: row.pghId,// 自行替换此参数
            });
            $.yvan.showDialog(this, dlg);
          }
        }
      ]
    }

    return {
      center: {
        border: false,
        items: {
          onRender: function () {
            $grid = $(this);
            queryGrid1();
          },
          xtype: 'grid',
          idField: "pghId",
          toolbar: {
            xtype: 'div',
            items: [
              queryToolbar,
              queryForm,
              gridToolbar
            ]
          },
          columns: [[
            {title: '派工ID', field: 'pghId', hidden: true},
            {title: '派工号', field: 'pghCode'},
            {title: '派工号名称', field: 'pghName', hidden: true},
            {title: '派工号类型', field: 'pghType', align: 'center', formatter: $.fn.fmatter.pghTypeSrc},
            {title: '机型管理', field: 'apmId', hidden: true},
            {title: '机型', field: 'apmName'},
            {title: '制造号', field: 'apIdcard'},
            {title: '机尾号', field: 'apIdtail'},
            {title: '维修类别', field: 'mfLev', align: 'center', formatter: $.fn.fmatter.mfLevSrc},
            {title: '送修单位', field: 'apOwner'},
            {title: '投产日期', field: 'mfStart', align: 'center', formatter: $.fn.fmatter.tsymd},
            {title: '交付日期', field: 'mfEnd', align: 'center', formatter: $.fn.fmatter.tsymd},
            {title: '备注', field: 'remark', hidden: true},
            {title: '整体状态', field: 'status', hidden: true},
            {title: '整体状态', field: 'allStatusView', align: 'center', formatter: $.fn.fmatter.allStatusView},
            {title: '发布时间', field: 'pubTime', formatter: $.fn.fmatter.ts, hidden: true},
            {title: '新增人', field: 'userCreate', align: 'center', hidden: true},
            {title: '新增时间', field: 'timeCreate', formatter: $.fn.fmatter.ts},
            {title: '更新人', field: 'userUpdate', align: 'center', hidden: true},
            {title: '更新时间', field: 'timeUpdate', formatter: $.fn.fmatter.ts}
          ]]
        }
      }
    };
  };
});