define(function (require) {
  return function (context) {

    var $grid1, $grid2, $form;

    // 回车查询列表
    function enterQueryGrid1(e) {
      if (e.keyCode === 13) {
        var tmp = $(this).val();
        $form.formSet({queryProperties: tmp});
        queryGrid1();
      }
    }

    function queryGrid1() {
      $grid1.jqGrid("clearGridData");
      var obj = $form.formGet();
      $grid1.reload({
        url: api('/hr/user/queryUserList'),
        mtype: 'POST',
        queryParams: obj
      });
      if ($grid2 != undefined && $grid2 != null) {
        $grid2.jqGrid("clearGridData");
      }
    }

    function queryGrid2(rowid) {
      var row = $grid1.rowData(rowid);
      if (!row) {
        $.yvan.msg('请先选择一行数据');
        return;
      }
      $grid2.reload({
        url: api('/wms/farmUser/queryFarmUserRole'),
        mtype: 'POST',
        queryParams: {userId: row.userId}
      });
    }

    return {
      north: {
        height: 90,
        split: true,
        border: false,
        items: [
          {
            xtype: 'toolbar', title: '通讯录',
            items: [
              {
                text: '查询', iconCls: 'fa fa-search', onClick: function () {
                  queryGrid1();
                }
              }, {
                text: '重置', iconCls: 'fa fa-refresh', onClick: function () {
                  $form.formClear();
                  queryGrid1();
                }
              }, {
                text: '关闭', iconCls: 'fa fa-times-circle', onClick: function () {
                  App.closeMe();
                }
              }
            ]
          }, {
            xtype: 'form',
            items: [[
              {
                xtype: 'textbox',
                label: '检索条件',
                name: 'queryProperties',
                prompt: '姓名/手机号/职工号/部门',
                labelWidth: 'auto',
                events: {keydown: enterQueryGrid1}
              },
              {
                xtype: 'yvselect', label: '性别', name: 'gender', labelWidth: 'auto', width: 150,
                data: $.yvan.sysDict('gender').combowithAll(),
                onChange: function () {
                  queryGrid1();
                }
              },
              {
                xtype: 'yvselect', label: '在职状态', name: 'status', labelWidth: 'auto', width: 180,
                data: $.yvan.sysDict('userStatus').combowithAll(),
                onChange: function () {
                  queryGrid1();
                }
              }
            ]],
            onRender: function () {
              $form = $(this);
            }
          }
        ]
      },
      center: {
        border: false,
        items: {
          xtype: 'grid',
          caption: '员工通讯录',
          border: false,
          pagination: true,
          idField: 'packID',
          columns: [[
            {title: '用户编号', field: 'userId', hidden: true},
            {title: '姓名', field: 'name'},
            {title: '性别', field: 'gender', align: 'center', formatter: $.fn.fmatter.genderSrc},
            {title: '手机号', field: 'mobile'},
            {title: '职工号', field: 'jobcard'},
            {title: '部门', field: 'deptNames'},
            {title: '职位', field: 'roleNames'},
            {title: '在职状态', field: 'status', hidden: true},
            {title: '在职状态', field: 'userStatus', align: 'center', formatter: $.fn.fmatter.userStatusView},
          ]],
          onSelectRow: function (rowid) {
            //queryGrid2(rowid);
          },
          loadComplete: function () {
            //默认选中第一行
          },
          onRender: function () {
            $grid1 = $(this);
            queryGrid1(); //初始化数据
          }
        }
      },
      // south: {
      //   height: '40%',
      //   split: true,
      //   border: false,
      //   items: {
      //     xtype: 'grid',
      //     caption: '角色信息',
      //     border: false,
      //     pagination: true,
      //     columns: [[
      //       {field: 'wwuId', title: '流水ID', hidden: true},
      //       {field: 'userId', title: '用户ID', hidden: true},
      //       {field: 'name', title: '姓名'},
      //       {field: 'genderCN', title: '性别'},
      //       {field: 'farmName', title: '库区'},
      //       {field: 'roleName', title: '角色'},
      //       {field: 'nameCreate', title: '新增人'},
      //       {field: 'timeCreate', title: '新增时间', formatter: 'ts'}
      //     ]],
      //     onRender: function () {
      //       $grid2 = $(this);
      //     },
      //   }
      // }
    };
  };
});
